
/*   
     
chess-Ec    Copyright (C)   2001-2008 Marc Dechico


 ec_simu.c: Engine use to explore the tree game  and collect data.
   
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 37 98 22 54
 Mail: ec@chess-ec.org  
    
*/

#include "ec_simu.h"


/*****************************************************************************/
/*  Simulation                                                               */
/*****************************************************************************/
/* simulation pour controle mat pat */
int  simul_ctl(void)		     
{

  // defv_aff_not_pos = Y;
  // simul_ctl should'n interfer at all qith stats
  return (simul(2,0,
		USE_HASH_NO,
		USE_ALPHA_BETA_NO,
		INI_MVT_INI_NO,
		INI_RAP_FOR_NO,
		NULL, // for increment mvt_ini
		pts_hst_pro->i_cam));
}
long  simul_time(void)		     
{
  
  struct timeval a1,a2;
  //int err_msg;  
  gettimeofday(&a1,NULL);
  // simmul_time is only used to evaluate response time 
  // some stats should be used to interprete the result 
  // another statistique data strucuture should be used 
  // shouldn't interfere with the normal stats 
  // for the moment stats are no used 
  //defv_aff_not_pos = N;
  //err_msg=simul(2,0,
  simul(2,0,
		USE_HASH_NO,
		USE_ALPHA_BETA_NO,
		INI_MVT_INI_NO,
		INI_RAP_FOR_NO,
		NULL,
		pts_hst_pro->i_cam);

  gettimeofday(&a2,NULL);

  printf("\n Time to simul 2,0 msecond: %li", diff_time_mcs(a2,a1));
  return 0; 
}
/* retourne meilleur mouvement */	
int  simul    (int i_pro_sim_niv_wrk,			
	       int i_pro_sim_inc_wrk,
	       defv_bool defv_bool_use_hash,
	       defv_bool defv_bool_use_alpha_beta,
	       defv_bool defv_bool_ini_mvt_ini,
	       defv_bool defv_bool_ini_rap_for,
	       def_pf_not_cal pf_not_cal_arg,
	       int i_cam_adv
	       )		
{

 defv_bool_sigint = FALSE; 

 
#if LINUX == 1 
  st_sig_act.sa_handler	= sto_sim_set;
  st_sig_act.sa_mask	= NULL;
  st_sig_act.sa_flags	= SA_ONESHOT;
  sigaction(SIGINT,st_sig_act,NULL);
  sigaction(SIGTERM,st_sig_act,NULL);
#else
  signal(SIGINT,sto_sim_set);
  signal(SIGTERM,sto_sim_set);
#endif
#ifdef UPLOAD_BRANCHE
  bra_fre_mem(); 
  bra_ini_mem(20,100); 
#endif
  /* no alpha betat cut for statistic collect (l 4.0) */
  if( defv_bool_use_alpha_beta)
      i_alpha_beta_min_depth = 2;  
   else
     i_alpha_beta_min_depth =  i_pro_sim_niv_wrk +i_pro_sim_inc_wrk; 

  // printf("\nalpha mi depth: %d",i_alpha_beta_min_depth);

  /* which function not cal to use */
  pf_not_cal=pf_not_cal_arg;

  /* la simulation commence a pro_act + 1*/
  /* incrementee par profondeur suivante */

  i_pro_sim_act	= i_pro_act;
  pts_hst_pro = &ts_hst_pro[i_pro_sim_act];
  pts_hst_pro_p = &ts_hst_pro[i_pro_sim_act-1];
  
  /* profondeur de sim max  pour aff_hst */
  i_pro_sim_max_sup = i_pro_act + i_pro_sim_niv_wrk ;  		

  /* profondeur de sim max  pour aff_hst */
  i_pro_sim_max_inf = i_pro_sim_max_sup + i_pro_sim_inc_wrk;  	

  /* Verifie que ts_hst_pro est sufisament grand */
  if (i_pro_sim_max_inf > PRO_HST-1) return -MSG_SIMU_HST_SIZ ;
	
  /* profondeur d'interruption   clavier  */
  if(i_pro_sim_niv_wrk >2)                   
    i_pro_sim_int_cla	= i_pro_sim_max_sup -2; 
  else
    i_pro_sim_int_cla	= i_pro_sim_max_sup -1;
 
  /* init nbre de coup par niveaux */
  hst_cpt_raz(defv_bool_use_hash,i_cam_adv);

  /* init rapport de force */
   if(defv_bool_ini_rap_for)
     {
       pts_hst_pro->i_not = 0;
       pts_hst_pro->i_rap_for = 0;
     }

   pro_sui();
   /* initialisation  init de cpt pat mat */
   /* compteur mvt initiaux */
    i_not_cpt_mvt_ini 	= 0;

   if( defv_bool_ini_mvt_ini)
     {
       not_mvt_ini_raz( i_pro_sim_niv_wrk, i_pro_sim_inc_wrk);          

     }

  /* inititialisation of the has table */
#ifdef STHASH
    if(defv_bool_use_hash)
    ini_mem(& pst_hash1,0,0);
#endif

#if CPT_ITE == 1
  cpt = 0;
#endif
  /* controle boucle simulation */       
  defv_sim_end = CONTINUE;       

  /* faire while(1)
     et test à l'interieur de la boucle 
     si il faut arreter if(continue==O)
        alors break
     sinon 
     si signal d'interruption ( continue==S)
         question à l'utilisateur et 
         selon reponse modifier profondeur 
         puis continue (de la boucle)
         pour permettre un arret propre 
         du moteur     
  */
  while ( TRUE )
    {

      if ( defv_sim_end != CONTINUE )
	{
	  if( defv_sim_end == _SIGINT )
	    {
	      sto_sim_int();
	      defv_sim_end = CONTINUE;
	    }
	  if( defv_sim_end == _SIGTERM )
	    {
	      defv_bool_sigterm = TRUE;
	      sto_sim();
	      defv_sim_end = CONTINUE;
	    }
	  if ( defv_sim_end == STOP )
	    break;
	}
#if CPT_ITE == 1
      cpt++;
#endif
#if CTL_DEP_ECH_PIE == 1
      if (ctl_dep_nbr())
	{aff_ech(0);aff_pie_pre(0);aff_pie_pre(1);aff_hst(0,0);
	getchar();}
#endif

      (**pts_hst_pro->ptpf_mvt)();


    }

  /* reinitialisation du  pionteurs sur hst */
  pts_hst_pro 		= &ts_hst_pro[i_pro_act];
  pts_hst_pro_p 	= &ts_hst_pro[i_pro_act-1];

  /* initialisation du  pionteurs piece actuelle  */
  pts_pie = pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  // if the stats are regenerated save the number of initial movements. 
   if( defv_bool_ini_mvt_ini)
       pst_evaluation->i_number_of_initial_move=i_not_cpt_mvt_ini;

     
  /* Si aucun mouvement possibles verifie si mat ou pat */

  if (i_not_cpt_mvt_ini==0)
    {
      extern int i_end_gam;
      i_end_gam=1;
      if(pts_hst_pro->defv_ech == Y)
	{
	  if (pts_hst_pro->i_cam==0)
	    {
	      return -MSG_SIMU_MAT_BLANC;
	    }
	  else
	    {
	      return -MSG_SIMU_MAT_NOIR;

	    }
	}	
      else
	{
	  if (pts_hst_pro->i_cam==0)
	    {
	      return -MSG_SIMU_PAT_BLANC;
	    }
	  else
	    {
	      return -MSG_SIMU_PAT_NOIR;
	    }
	}
    }
#if CPT_ITE == 1
  printf("\ncpomteur iteration%lu", cpt);
#endif

  /* free the memory used by the hash */
#ifdef STHASH
    if(defv_bool_use_hash)  
    fre_mem(&pst_hash1);
#endif
  return 0;
}

/* fonctions calculant pour chaque direction  les nouvelles coordonnees       */
/* de la piece a partir de sa positin precedente                             */
void haut 			(void)
{
  pts_hst_pro->i_pos_n  HH;
  mvt_tfr();
}
void haut_droite  	(void)
{
  pts_hst_pro->i_pos_n  HD;
  mvt_tfr();
}
void droite 		(void)
{
  pts_hst_pro->i_pos_n  DD;
  mvt_tfr();
}
void bas_droite  	(void)
{
  pts_hst_pro->i_pos_n  BD;
  mvt_tfr();
}
void bas 			(void)
{
  pts_hst_pro->i_pos_n  BB;
  mvt_tfr();
}
void bas_gauche 	(void)
{
  pts_hst_pro->i_pos_n  BG;
  mvt_tfr();
}
void gauche 		(void)
{
  pts_hst_pro->i_pos_n  GG;
  mvt_tfr();
}
void haut_gauche 	(void)
{
  pts_hst_pro->i_pos_n HG;
  mvt_tfr();
}
/* cas particulier pour gestion du rock */
void haut_tou_pr  	(void)
{
  pts_hst_pro->i_pos_n  HH;
  mvt_tou_pr();
}
void bas_tou_pr  	(void)
{
  pts_hst_pro->i_pos_n  BB;
  mvt_tou_pr();
}
void haut_tou_gr  	(void)
{
  pts_hst_pro->i_pos_n  HH;
  mvt_tou_gr();
}
void bas_tou_gr  	(void)
{
  pts_hst_pro->i_pos_n  BB;
  mvt_tou_gr();
}
void gauche_tou_pr 	(void)
{
  pts_hst_pro->i_pos_n  GG;
  mvt_tou_pr();
}
void droite_tou_gr 	(void)
{
  pts_hst_pro->i_pos_n  DD;
  mvt_tou_gr();
}
void mvt_tfr 		(void)
{

  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
 
      /* deplace la piece */
      dep_sim();

      /* restore la piece prise au precedent mouvement */
      if (pts_hst_pro->i_typ_mvt == TFR_PRI) pie_pri_res();

      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= TFR_DEP;

      /* reinit pour retour profondeur inferieur */
      pts_hst_pro->defv_dir_sui = N;

      /* maj note dans hst */
      // pts_hst_pro->i_not = 0;
    }
  else
    {
      /* opti : its not usefull to store i_cam_adv in pts_ hst 
	 2  gloal variable could be set when changing level
	 would both spare cpu time and memory 
      */
      if (ts_ech[pts_hst_pro->i_pos_n].i_cam== pts_hst_pro->i_cam_adv )
	{
	  /* increment nombre de piece prise pour calcul nbr fourchette */
	  pts_hst_pro->i_nbr_pri_pie++;

	  /* opti : il serait peut etre bon de creer une fct pri_sim speciale pour ce cas 
	     qui inclue le restore a cause de l'ID2 qui est ecrasee */

	  /* restore les  pieces du mvt  prise precedent  */
	  if (pts_hst_pro->i_typ_mvt == TFR_PRI) pri_res();

	  /* effectue la prise */
	  pri_sim();
		
	  /* maj hst */
	  pts_hst_pro->i_typ_mvt = TFR_PRI;
	  pts_hst_pro->defv_dir_sui = Y;
	      	      
	  /* maj note dans hst */
	  //  maj_not();
	}
      else
	{
	  /* piece propre camp ou autre */
	  //	  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
    }
  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife a nouveau echec */
      /* 		par piece principale ou secondaire pro precedente ? */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (					/* principale/ secondaire */
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (					/* demasaquage pro precedente */
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (					/* demasquage pro actuelle */
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 )

	{
	  /* echec donc mvt impossible */
	  /* opti : maj note necessaire ? */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  if(pts_hst_pro->defv_dir_sui)
	    dir_sui();
	  return;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;

	}

    }
  else  	/* pas d'echec prof precedente */
    {
      /* Verifie echec propre camp par demasquage  */
      if
	(
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)

	 )

	{
	  /* echec donc mvt impossible */
	  //pts_hst_pro->i_not = NOT_MIN;
	  /* dir sui car ne peut prendre la piece causant echec */
	  dir_sui();
	  return;
	}
      else     /* pas d'echec */
	{

	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }
  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;

  /* verifie si cause echec camp adverse */
  /* par mvt piece principale ou par demasquage*/

  if (i_pro_sim_act < i_pro_sim_max_inf)
    {
      if
	(
	 (*pts_pie->pf_ech_par)
	 ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_c_a,
	   pts_hst_pro->i_cam)
	
	  )
	 )
	{
	  set_ech_on();

	}
      else
	{
	  set_ech_off();
	}
    }
  /* opti c'est la qu'il faudrait faire le cut lorsque la perte est trop forte 
    seulement pour le camp qui va jouer! le c'est pas symetrique!
   le probleme c'est qu'il faut trouver un seuil (dynamique?)*/
#ifdef STHASH  
    if(pts_hst_pro->pf_hash_add_lx != NULL)
      if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
  	return;
#else
#ifdef STHASH1  
  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;

#else

#endif
#endif

  if
    (
     // mvt_tfr
     i_pro_sim_act<i_pro_sim_max_sup
     ||
     (
      (
       //       (!pts_hst_pro->defv_ene) 
       //||
       ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
       ||
       pts_hst_pro->defv_ech 
       )
      //&&
      //abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT
      &&
      i_pro_sim_act<i_pro_sim_max_inf
      )
     )
    {
		

      /* descendre ds l'arborescence */
      pro_sui();

      /* recopie valeur grd et petit rock pour cam propre */
      cop_val_prc_pc();
      cop_val_grc_pc();
     
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();
     
    }
  else
    {

     maj_not_max_at_leaf();
#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  

     /* direction suivante meme pro */
      if(pts_hst_pro->defv_dir_sui)
	dir_sui();
      return;
    }

}
/* pour tour se trouvant en position d'origine et maj ti_cam_roc */
void mvt_tou_pr 		(void)
{

  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
      /* Efectue deplacement */
      dep_sim();

      /* restore la piece prise au precedent mouvement */
      if (pts_hst_pro->i_typ_mvt == TFR_PRI) pie_pri_res();

      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= TFR_DEP;

      /* reinit pour retour profondeur inferieur */
      pts_hst_pro->defv_dir_sui = N;
 
      /* maj note dans hst */
            if (pts_hst_pro->ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC])
	/* roc deja effectue */
          	pts_hst_pro->i_not = 0;
         else
         	pts_hst_pro->i_not += NOT_ROC_TOU;
    }
  else
    {
      if (ts_ech[pts_hst_pro->i_pos_n].i_cam==  pts_hst_pro->i_cam_adv	  )

	{
	  /* increment nombre de piece prise pour calcul nbr fourchette */
	  pts_hst_pro->i_nbr_pri_pie++;

	  /* restore les pieces du mvt prise precedent */
	  if (pts_hst_pro->i_typ_mvt == TFR_PRI) pri_res();
	      
	  /* effectue la prise */
	  pri_sim();
	
	  /* prise simple */
	  pts_hst_pro->i_typ_mvt = TFR_PRI;
	  pts_hst_pro->defv_dir_sui = Y;
	      
      
	  //	  /* maj note dans hst */
	  //	  maj_not();
		
	}
      else
	{
	  /* piece propre camp ou autre */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
    }

  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife a nouveau echec */
      /* 		par piece principale pro precedente ? */
      /* 	ou	par piece secondaire pro precedente */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 )

	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  if(pts_hst_pro->defv_dir_sui)
	    dir_sui();
	  return;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;

	}

    }
  else  	/* pas d'echec prof precedente */
    {
      /* Verifie echec propre camp par demasquage  */
      if
	( /* bug plutot echec par tour */
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)

	 )

	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  /* dir sui car ne peut prendre la piece causant echec */
	  dir_sui();
	  return;
	}
      else     /* pas d'echec */
	{

	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }

  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;

  /* verifie si cause echec camp adverse */
  /* par mvt piece principale ou par demasquage*/
  if (i_pro_sim_act < i_pro_sim_max_inf)
    {
 
      if
	(
	 ech_par_tou ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)

	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_c_a,
	   pts_hst_pro->i_cam)

	  )
	 )
	{
	  set_ech_on();
	}
      else
	{
	  set_ech_off();
	}
    }

#ifdef STHASH  
    if(pts_hst_pro->pf_hash_add_lx != NULL)
    if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
  	return;
#else
#ifdef STHASH1  
  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;
#else
#endif
#endif
  if
    (
     //mvt_tou_pr
     i_pro_sim_act<i_pro_sim_max_sup
     ||
     (
      (
       //(!pts_hst_pro->defv_ene) 
       //||
       ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
       ||
       pts_hst_pro->defv_ech
       )
      //&&
      //abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT

      &&
      i_pro_sim_act<i_pro_sim_max_inf
      )
     )
    {

      /* descendre ds l'arborescence */
      pro_sui();
      /* recopie valeur grd et petit rock pour cam propre */
      /*  petit rock plus possible: modife valeur par defaut */
      pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
      cop_val_grc_pc();
      
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();

    }
  else
    {

      maj_not_max_at_leaf();

#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  


    /* direction suivante meme pro */
      if(pts_hst_pro->defv_dir_sui)
	dir_sui();
      return;
    }

}
void mvt_tou_gr 		(void)
{

  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
      /* deplace la piece */
      dep_sim();

      /* restore la piece prise au precedent mouvement */
      if (pts_hst_pro->i_typ_mvt == TFR_PRI) pie_pri_res();

      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= TFR_DEP;

      /* reinit pour retour profondeur inferieur */
      pts_hst_pro->defv_dir_sui = N;
      /* maj note dans hst */
        if (pts_hst_pro->ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC])
	/* roc deja effectue */
      	pts_hst_pro->i_not = 0;
        else
      	pts_hst_pro->i_not += NOT_ROC_TOU;
 
    }
  else
    {
      if (ts_ech[pts_hst_pro->i_pos_n].i_cam== pts_hst_pro->i_cam_adv	  )
	{

	  /* increment nombre de piece prise pour calcul nbr fourchette */
	  pts_hst_pro->i_nbr_pri_pie++;

	  /* restore les  pieces du mvt  prise precedent  */
	  if (pts_hst_pro->i_typ_mvt == TFR_PRI) pri_res();

	  /* effectue la prise */
	  pri_sim();
	
	  /* prise simple */
	  pts_hst_pro->i_typ_mvt = TFR_PRI;
	  pts_hst_pro->defv_dir_sui = Y;
	      
	  //	  /* maj note dans hst */
	  //	  maj_not();
	}
      else
	{
	  /* piece propre camp ou autre */
	  //	  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
    }

  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife a nouveau echec */
      /* 		par piece principale pro precedente ? */
      /* 	ou	par piece secondaire pro precedente ? */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 )

	{
	  /* echec donc mvt impossible */
	  //	  pts_hst_pro->i_not = NOT_MIN;
	  if(pts_hst_pro->defv_dir_sui)
	    dir_sui();
	  return;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;

	}

    }
  else  	/* pas d'echec prof precedente */
    {
      /* Verifie echec propre camp par demasquage  */
      if
	(
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)

	 )

	{
	  /* echec donc mvt impossible */
	  //	  pts_hst_pro->i_not = NOT_MIN;
	  /* dir sui car ne peut prendre la piece causant echec */
	  dir_sui();
	  return;
	}
      else     /* pas d'echec */
	{

	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }
  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;

  /* verifie si cause echec camp adverse */
  /* par mvt piece principale ou par demasquage*/
  if (i_pro_sim_act < i_pro_sim_max_inf)
    {
 
      if
	(
	 ech_par_tou  ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)

	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_c_a,
	   pts_hst_pro->i_cam)

	  )
	 )
	{
	  set_ech_on();

	}
      else
	{
	  set_ech_off();
	}
    }
#ifdef STHASH  
  if(pts_hst_pro->pf_hash_add_lx != NULL)
      if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
      return;
#else
#ifdef STHASH1  
  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;
#else
#endif
#endif

  if
    (
     //mvt_tou_gr
     i_pro_sim_act<i_pro_sim_max_sup
     ||
     (
      ( 
       //(!pts_hst_pro->defv_ene) 
       //||
       ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
       ||
       pts_hst_pro->defv_ech
       )
      //&&
      //abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT
      &&
      i_pro_sim_act<i_pro_sim_max_inf
      )
     )
    {

      /* descendre ds l'arborescence */
      pro_sui();
      /* recopie valeur grd et petit rock pour cam propre */
      cop_val_prc_pc();
      /* grd  rock plus possible: modife valeur par defaut */
      pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();
    }
  else
    {
      maj_not_max_at_leaf();
#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  

      /* direction suivante meme pro */
      if(pts_hst_pro->defv_dir_sui)
	dir_sui();
      return;
    }

}

/* pour cavalier */
void haut_droite_C 	(void)
{
  pts_hst_pro->i_pos_n CHD;
  mvt_cav();

}
void droite_haut_C 	(void)
{
  pts_hst_pro->i_pos_n CDH;
  mvt_cav();

}
void droite_bas_C 	(void)
{
  pts_hst_pro->i_pos_n CDB;
  mvt_cav();

}
void bas_droite_C 	(void)
{
  pts_hst_pro->i_pos_n CBD;
  mvt_cav();

}
void bas_gauche_C 	(void)
{
  pts_hst_pro->i_pos_n CBG;
  mvt_cav();

}
void gauche_bas_C 	(void)
{
  pts_hst_pro->i_pos_n CGB;
  mvt_cav();

}

void gauche_haut_C	(void)
{
  pts_hst_pro->i_pos_n CGH;
  mvt_cav();

}
void haut_gauche_C  (void)
{
  pts_hst_pro->i_pos_n CHG;
  mvt_cav();

}
void mvt_cav 		(void)
{
 
  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
      /* deplace la piece */
      dep_sim();
      /* restore la piece prise au precedent mouvement */
      if (pts_hst_pro->i_typ_mvt == CAV_PRI) pie_pri_res();
 
      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= CAV_DEP;

      /* maj note dans hst */
      // pts_hst_pro->i_not = 0;

    }
  else
    {
      if (ts_ech[pts_hst_pro->i_pos_n].i_cam== pts_hst_pro->i_cam_adv	  )

	{

	  /* increment nombre de piece prise pour calcul nbr fourchette */
	  pts_hst_pro->i_nbr_pri_pie++;

	  /* restore les  pieces du mvt  prise precedent  */
	  if (pts_hst_pro->i_typ_mvt == CAV_PRI) pri_res();

	  /* effectue la prise */
	  pri_sim();
		
	  /* prise simple */
	  pts_hst_pro->i_typ_mvt = CAV_PRI;
	      
	  /* maj note dans hst */
	  //	  maj_not();

	}
      else
	{
	  /* piece propre camp ou autre */
	  //	  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
    }

  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife a nouveau echec */
      /* 		par piece principale pro precedente ? */
      /* 	ou	par piece secondaire pro precedente ? */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 )

	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;

	}

    }
  else  	/* pas d'echec prof precedente */
    {
      /* Verifie echec propre camp par demasquage  */
      if
	(
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)

	 )

	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
      else     /* pas d'echec */
	{

	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }

  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;

  /* verifie si cause echec camp adverse */
  /* par mvt piece principale ou par demasquage*/
  if (i_pro_sim_act < i_pro_sim_max_inf)
    {
 
      if
	(
	 ech_par_cav 
	 ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_c_a,
	   pts_hst_pro->i_cam)

	  )
	 )
	{
	  set_ech_on();

	}
      else
	{
	  set_ech_off();
	}
    }
#ifdef STHASH  
    if(pts_hst_pro->pf_hash_add_lx != NULL)
    if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
  	return;
#else
#ifdef STHASH1  

  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;
#else
#endif
#endif

  if
    (
     //mvt_cav
     i_pro_sim_act<i_pro_sim_max_sup
     ||
     (	
      (
       //(!pts_hst_pro->defv_ene) 
       //||
       ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
       ||
       pts_hst_pro->defv_ech
       )
      //&&
      //abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT
      &&
      i_pro_sim_act<i_pro_sim_max_inf
      )
     )

    {

      /* descendre ds l'arborescence */
      pro_sui();

      /* recopie valeur grd et petit rock pour cam propre */
      cop_val_prc_pc();
      cop_val_grc_pc();
		
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();
		

    }
  else
    {
      maj_not_max_at_leaf();
#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  

      /* direction suivante meme pro */
      dir_sui();
      return;
    }

}

/* pour roi */
void haut_gauche_R 	(void)
{
  pts_hst_pro->i_pos_n HG;
  mvt_roi();

}
void haut_droite_R 	(void)
{
  pts_hst_pro->i_pos_n HD;
  mvt_roi();

}
void bas_gauche_R 	(void)
{
  pts_hst_pro->i_pos_n BG;
  mvt_roi();


}
void bas_droite_R  	(void)
{
  pts_hst_pro->i_pos_n BD;
  mvt_roi();

}
void haut_R 		(void)
{
  pts_hst_pro->i_pos_n HH;
  mvt_roi();

}
void bas_R			(void)
{
  pts_hst_pro->i_pos_n BB;
  mvt_roi();

}
void gauche_R 		(void)
{
  pts_hst_pro->i_pos_n GG;
  mvt_roi();

}
void droite_R 		(void)
{
  pts_hst_pro->i_pos_n DD;
  mvt_roi();

}
void grd_roc_0 	(void)
{

  /* restore piece principale */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();
      
  /* opti a integrer dans instructin  suivante */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;

  pts_hst_pro->i_pos_n= C1;

  if
    (
     pts_hst_pro->i_cam != BLANC  		 /* blanc */
     ||
     pts_hst_pro->
     ti_roc_cam_typ[BLANC][GRA_ROC]	 /* roi ou tour deplacee */
     ||
     ts_ech[A1].i_Id!=
     ti_tou_cam_typ[BLANC][GRA_ROC]	 /* tour supprimee car pas deplacee*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[B1].i_cam!=VIDE			   	 /* case intermedaire  non vide*/
     ||
     ts_ech[C1].i_cam!=VIDE
     ||
     ts_ech[D1].i_cam!=VIDE
     ||
     ctl_par_xxx	(B1)        /* ou sous ctl adversaire */
     ||								 /* bug: voir si sous cntrole roi */ 
     ctl_par_xxx	(C1)
     ||
     ctl_par_xxx	(D1)
     )
    {
      // pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_GRA_ROC;                /*grd rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      /* maj note dans hst */
      //  pts_hst_pro->i_not = 0;

      dep_grd_roc_0();                            /* mvt des pieces */
      // mvt_roi_gra_roc(D1);
      mvt_roi_roc(D1);
    }

}
void grd_roc_1 	(void)
{

  /* restore piece principale */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();
      
  /* opti a integrer dans instructin  suivante */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;

  pts_hst_pro->i_pos_n = C8;

  if
    (
     pts_hst_pro->i_cam != NOIR			  /* noir  */
     ||
     /* bug : pas initialisee?  pas fiable */
     pts_hst_pro->
     ti_roc_cam_typ[NOIR][GRA_ROC]		  /* roi ou tour deplacee */
     ||
     ts_ech[A8].i_Id!=
     ti_tou_cam_typ[NOIR][GRA_ROC]	   	 /* tour supprimee car pas deplacee*/
     ||
     pts_hst_pro_p->defv_ech	    		  /* echec prof precedente */
     ||
     ts_ech[B8].i_cam!=VIDE		   	  /* case intermedaire non vide*/
     ||
     ts_ech[C8].i_cam!=VIDE
     ||
     ts_ech[D8].i_cam!=VIDE
     ||
     ctl_par_xxx	(B8)         /*  ou sous ctl adversaire */
     ||
     ctl_par_xxx	(C8)
     ||
     ctl_par_xxx	(D8)
     )
    {
      //   pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_GRA_ROC;                /* grand rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      /* maj note dans hst */
      //     pts_hst_pro->i_not = 0;

      dep_grd_roc_1();                            /* mvt des pieces */
      // mvt_roi_gra_roc(D8);
      mvt_roi_roc(D8);
    }
}
void pet_roc_0 	(void)
{

  /* restore piece principale */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();

  /* opti a integrer dans instructin  suivante */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;

  pts_hst_pro->i_pos_n =G1;

  if
    (
     pts_hst_pro->i_cam != BLANC  		 /* blanc */
     ||
     pts_hst_pro->
     ti_roc_cam_typ[BLANC][PET_ROC]       	 /* roi ou tour deplacee */
     ||
     ts_ech[H1].i_Id!=
     ti_tou_cam_typ[BLANC][PET_ROC]	 /* tour supprimee car pas deplacee*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[F1].i_cam!=VIDE		   	 /* case intermedaire non vide*/
     ||
     ts_ech[G1].i_cam!=VIDE
     ||
     ctl_par_xxx	(F1)        /* ou sous ctl adversaire */
     ||
     ctl_par_xxx	(G1)
     )
    {
      //   pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_PET_ROC;                /*petit rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      /* maj note dans hst */
      //   pts_hst_pro->i_not = 0;

      dep_pet_roc_0();                            /* mvt des pieces */
      // mvt_roi_pet_roc(F1);
      mvt_roi_roc(F1);
    }
}
void pet_roc_1 	(void)
{
  /* opti :  mettre en fonction */
  /* restore piece principale */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();
      
  /* opti a integrer dans instructin  suivante */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;


  pts_hst_pro->i_pos_n =G8;

  if
    (
     pts_hst_pro->i_cam != NOIR  		 /* noir */
     ||
     pts_hst_pro->
     ti_roc_cam_typ[NOIR][PET_ROC] 		 /* roi ou tour deplacee */
     ||
     ts_ech[H8].i_Id!=
     ti_tou_cam_typ[NOIR][PET_ROC]	   	 /* tour supprimee car pas deplacee*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[F8].i_cam!=VIDE		   	 /* case intermedaire non vide*/
     ||
     ts_ech[G8].i_cam!=VIDE
     ||
     ctl_par_xxx	(F8)        /* ou sous ctl adversaire */
     ||
     ctl_par_xxx	(G8)
     )
    {
      // pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_PET_ROC;                /*petit rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      /* maj note dans hst */
      // pts_hst_pro->i_not = 0;

      dep_pet_roc_1();                            /* mvt des pieces */
      //      mvt_roi_pet_roc(F8);
      mvt_roi_roc(F8);
    }

}
void mvt_roi_roc 		(int i_pos_n_tou)
{
  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;
#ifdef STHASH  
    if(pts_hst_pro->pf_hash_add_lx != NULL)
    if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
  	return;
#else
#ifdef STHASH1
  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;
#else
#endif
#endif

  /*  if 	(i_pro_sim_act<i_pro_sim_max_sup)*/
    /*bug pourquoi ne pas prendre en compte l'increement?
     parceque on increemente en cas de pise ou d'eechec et 
    que c'est impossible dans ce cas 
    mais alors pourquoi se limiter si  limite superieur=3 c'est 
     un cut abusif!    */
  if 	(
	 //mvt_roi_gra_roc
	 //abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT
	 //&&
	 i_pro_sim_act<i_pro_sim_max_inf
	)
    {
      /* verifie si cause echec camp adverse */
      /* par la tour */
      if (
	  ech_par_tou (
		       /* (pts_hst_pro->pts_pie_pc+pts_hst_pro->i_Id_2p)->i_pos_n,*/
		       i_pos_n_tou,
		       pts_hst_pro->i_pos_n_R_c_a
		       )
	  )
	set_ech_on();
      else
	set_ech_off();
	

      /* descendre ds l'arborescence */
      pro_sui();
      /* recopie valeur grd et petit rock pour cam propre */
      /* petit et grd rock plus possible */
      pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
      pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;
		
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();

    }
  else
    {
      maj_not_max_at_leaf();
#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  

      /* direction suivante meme pro */
      dir_sui();
      return;
    }

}

void mvt_roi 		(void)
{
  /* la tour roc pourrait empecher deplacement au lieu de restorer la tour 
     je met dep_roc en fin du tableau mvt comme cela un roc ne peut precedee ce mvt */
  /*tst */
  
  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
 
      /* deplace la piece */
      dep_sim();

      /* restore la piece prise au precedent mouvement */
      if (pts_hst_pro->i_typ_mvt == ROI_PRI) pie_pri_res();

      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= ROI_DEP;

      /* preserve possibilié de roc  */
      if (!(	    
	    pts_hst_pro->ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]
	    ||
	    pts_hst_pro->ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]
	    )
      	  )
      	pts_hst_pro->i_not += NOT_ROC_TOU;
    }
  else
    {
      if (ts_ech[pts_hst_pro->i_pos_n].i_cam==pts_hst_pro->i_cam_adv )

	{
	  /* increement nombre de piece prise pour calcul nbr fourchette */
	  pts_hst_pro->i_nbr_pri_pie++;

	  /* restore les  pieces du mvt  prise precedent  */
	  if (pts_hst_pro->i_typ_mvt == ROI_PRI) pri_res();

	  /* effectue la prise */
	  pri_sim();
		
	  /* prise simple */
	  pts_hst_pro->i_typ_mvt = ROI_PRI;	      
		      
	  /* maj note dans hst */
	  //	  maj_not();
	}
      else
	{
	  /* piece propre camp ou autre */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
    }

  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verifie si roi a nouveau echec (toute direction )*/
      if (ctl_par_xxx (pts_hst_pro->i_pos_n) )
	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
      else    /* roi n'est plus echec */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;
	}

    }
  else  /* pas d'echec pro precedente */
    {
 
      /* verifie si roi se retrouve echec (toute direction )*/
      if (ctl_par_xxx	(pts_hst_pro->i_pos_n)   )
	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
      else
	{
	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;
	}
    }

  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;


  /* verifie si cause echec camp adverse */
  /* par par demasquage*/
  if (i_pro_sim_act < i_pro_sim_max_inf)
    {
 
      if
	(
	 pts_hst_pro->i_ech_dir_dem
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	 (pts_hst_pro->i_pos_n_R_c_a,
	  pts_hst_pro->i_cam)

	 )
	{
	  set_ech_on();

	}
      else
	{
	  set_ech_off();
	}
    }
#ifdef STHASH  
  if(pts_hst_pro->pf_hash_add_lx != NULL)
      if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
      return;
#else
#ifdef STHASH1  
  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;
#else
#endif
#endif

  if
    (
     //mvt_roi
     i_pro_sim_act<i_pro_sim_max_sup
     ||
     (
      (
       //(!pts_hst_pro->defv_ene) 
       //||
       ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
       ||
       pts_hst_pro->defv_ech
       )
      //&&
      // abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT
       &&
      i_pro_sim_act<i_pro_sim_max_inf
      )
     )

    {


      /* descendre ds l'arborescence */
      pro_sui();
      /* recopie valeur grd et petit rock pour cam propre */
      /* petit et grd rock plus possible */
      pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
		
      pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;
		
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();
    }
  else
    {
     maj_not_max_at_leaf();
#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  

      /* direction suivante meme pro */
      dir_sui();
      return;
    }
}

/* pour pion camp 0 */

void haut_1_p_0 	(void)
{
  pts_hst_pro->i_pos_n PH1;
  mvt_pio_1C();
}
void bas_1_p_1 	(void)
{
  pts_hst_pro->i_pos_n PB1;
  mvt_pio_1C();
 
}
void mvt_pio_1C (void)
{
  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
      /* deplace la piece */
      dep_sim();

      /* restore la piece prise au precedent mouvement */
      if (
	  pts_hst_pro->i_typ_mvt == PIO_PRI
	  ||
	  pts_hst_pro->i_typ_mvt == PIO_PRI_PAS

	  ) pie_pri_res();

      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= PIO_1C;

      /* maj note dans hst */
      // pts_hst_pro->i_not = 0;

    }
  else
    {
      /* piece propre camp ou autre */
      //  pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
      return;
    }
  mvt_pio(0); /* parametre:0> pas prise en passant */ 

}
void haut_2_p_0		(void)
{
  pts_hst_pro->i_pos_n PH2;
  mvt_pio_2C(-10); 
  /* parametre: -10> decalage relatif a position d'arriveee 
     pour verife  case vide */
}
void bas_2_p_1		(void)
{
  pts_hst_pro->i_pos_n PB2;
  mvt_pio_2C(10); 
  /* parametre: 10 > decalage relatif a position d'arriveee 
     pour veerife  case vide */

}
void mvt_pio_2C (int i_dec_pos)
{
  /* pas de restore de piece car premier mvt dans table et donc
     a eete effectuee par pie_sui  ou alors premier mvt apres prof_sui */
  if
    (
     ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE
     &&
     ts_ech[pts_hst_pro->i_pos_n + i_dec_pos].i_cam == VIDE

     )
    {
      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= PIO_2C;
      /* maj note dans hst */
      //   pts_hst_pro->i_not = 0;

      dep_sim();
    }
  else
    {
      /* piece propre camp ou autre */
      //  pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
      return;
    }
  mvt_pio(0); /* parametre:0> pas prise en passant */ 
}
void haut_gauche_p_0(void)
{
  pts_hst_pro->i_pos_n PHG;
  mvt_pio_pri();
}
void haut_droite_p_0(void)
{
  pts_hst_pro->i_pos_n PHD;
  mvt_pio_pri();
}
void bas_gauche_p_1(void)
{
  pts_hst_pro->i_pos_n PBG;
  mvt_pio_pri();
}
void bas_droite_p_1(void)
{
  pts_hst_pro->i_pos_n PBD;
  mvt_pio_pri();
}
void mvt_pio_pri(void)
{
  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == pts_hst_pro->i_cam_adv )

    {
      /* increement nombre de piece prise pour calcul nbr fourchette */
      pts_hst_pro->i_nbr_pri_pie++;

      /* restore la piece prise au precedent mouvement */
      if (
	  pts_hst_pro->i_typ_mvt == PIO_PRI
	  ||
	  pts_hst_pro->i_typ_mvt == PIO_PRI_PAS
	  )
	pri_res();	
 	
      /* effectue la prise */
      pri_sim();

      /* prise simple */
      pts_hst_pro->i_typ_mvt = PIO_PRI;
   
      /* maj note dans hst */
      //   maj_not();
    }
  else
    {
      /* piece propre camp ou autre */
      //  pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
      return;
    }
  mvt_pio(0);/* parametre:0> pas prise en passant */ 
}

void haut_gauche_pas_p_0(void)
{
  pts_hst_pro->i_pos_n PHG;
  mvt_pio_pri_pas(+10,-10); 
}
void haut_droite_pas_p_0(void)
{
  pts_hst_pro->i_pos_n PHD;
  mvt_pio_pri_pas(+10,-10);
}
void bas_gauche_pas_p_1(void)
{
  pts_hst_pro->i_pos_n PBG;
  mvt_pio_pri_pas(-10,+10);
}	
void bas_droite_pas_p_1(void)
{
  pts_hst_pro->i_pos_n PBD;
  mvt_pio_pri_pas(-10,+10);
}
void mvt_pio_pri_pas (int i_inc_ori,int i_inc_arr)
{
  /* parametre decalage a faire sur mvt profondeur precedente
     pour verifier si un pion a fait saut de 2 cases */

  if
    (
     (pts_hst_pro_p->pts_pie_pc +pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
     &&
     /*  verif position de deepart du pion a prendre */
     pts_hst_pro_p->i_pos_ori_n == pts_hst_pro->i_pos_n +i_inc_ori
     &&
     /* verif position d'arriveee du pion a  prendre   */
     pts_hst_pro_p->i_pos_n     == pts_hst_pro->i_pos_n + i_inc_arr
     )

    {
      /* increement nombre de piece prise pour calcul nbr fourchette */
      pts_hst_pro->i_nbr_pri_pie++;

      /* restore la piece prise au precedent mouvement */
      if (
	  pts_hst_pro->i_typ_mvt == PIO_PRI
	  ||
	  pts_hst_pro->i_typ_mvt == PIO_PRI_PAS
	  ) pri_res();
	  	
      /* effectue la prise */
      pri_pas();

      /* memorise type de mvt  */
      pts_hst_pro->i_typ_mvt = PIO_PRI_PAS;
	      
	      
      /* maj note dans hst */
      // maj_not();
    }
  else
    {
      /* piece propre camp ou autre */
      //  pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
      return;
    }
  mvt_pio(1);
}

void haut_gauche_cav_p_0(void)
{
  pts_hst_pro->i_pos_n PHG;
  mvt_pio_pro_pri(set_pie_cav_blanc,PIO_PRO_CAV_PRI); 
}
void haut_droite_cav_p_0(void)
{
  pts_hst_pro->i_pos_n PHD;
  mvt_pio_pro_pri(set_pie_cav_blanc,PIO_PRO_CAV_PRI);
} 
void haut_gauche_rei_p_0(void)
{
  pts_hst_pro->i_pos_n PHG;
  mvt_pio_pro_pri(set_pie_rei_blanc,PIO_PRO_REI_PRI);
}
void haut_droite_rei_p_0(void)
{ 
  pts_hst_pro->i_pos_n PHD;
  mvt_pio_pro_pri(set_pie_rei_blanc,PIO_PRO_REI_PRI);
}
void bas_gauche_cav_p_1(void)
{ 
  pts_hst_pro->i_pos_n PBG;
  mvt_pio_pro_pri(set_pie_cav_noir,PIO_PRO_CAV_PRI); 
}
void bas_droite_cav_p_1(void)
{ 
  pts_hst_pro->i_pos_n PBD;
  mvt_pio_pro_pri(set_pie_cav_noir,PIO_PRO_CAV_PRI); 
}
void bas_gauche_rei_p_1(void)
{ 
  pts_hst_pro->i_pos_n PBG;
  mvt_pio_pro_pri(set_pie_rei_noir,PIO_PRO_REI_PRI); 
}
void bas_droite_rei_p_1(void)
{  
  pts_hst_pro->i_pos_n PBD;
  mvt_pio_pro_pri(set_pie_rei_noir,PIO_PRO_REI_PRI); 
}
void mvt_pio_pro_pri ( void (*pf_set_pie) (void),int i_typ_mvt)
{
  /* restore toutes les pieces  */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();
      
  /* Dans le cas ou le mvt ne serait pas possible  */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;


  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == pts_hst_pro->i_cam_adv  )
    {
      /* increement nombre de piece prise pour calcul nbr fourchette */
      pts_hst_pro->i_nbr_pri_pie++;

      /* effectue la prise */
      pri_sim();

      /* meemorise type de mouvement  */
      pts_hst_pro->i_typ_mvt = i_typ_mvt;
	
      /* transforme le pion en cavalier */
      (*pf_set_pie)();

      /* maj note dans hst */
      // maj_not();

      /* incremente la note de la force du cavalier */
      inc_for_pio();

    }
  else
    {
      /* piece propre camp ou autre */
      //   pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
      return;
    }
  mvt_pio(0);
}

void haut_cav_p_0 	(void)
{
  pts_hst_pro->i_pos_n PH1;
  mvt_pio_pro(set_pie_cav_blanc,PIO_PRO_CAV); 
}
void haut_rei_p_0 	(void)
{ 
  pts_hst_pro->i_pos_n PH1;
  mvt_pio_pro(set_pie_rei_blanc,PIO_PRO_REI); 
}

void bas_cav_p_1 	(void)
{
  pts_hst_pro->i_pos_n PB1;
  mvt_pio_pro(set_pie_cav_noir,PIO_PRO_CAV); 
}
void bas_rei_p_1 	(void)
{
  pts_hst_pro->i_pos_n PB1;
  mvt_pio_pro(set_pie_rei_noir,PIO_PRO_REI); 
}

void mvt_pio_pro ( void (*pf_set_pie) (void),int i_typ_mvt)
{
  /* restore piece principale */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();
      
  /* plus besoin de restore si mvt pas execute  */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;


  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {	
      /* deplace la piece */
      dep_sim();

   
      /* transforme le pion en cavalier */
      (*pf_set_pie)();
	
      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= i_typ_mvt;
	    
      /* maj note dans hst */
      //  pts_hst_pro->i_not = 0;
			
      /* incremente la note de la force du cavalier */
      inc_for_pio();
    }
  else
    {
      /* piece propre camp ou autre */
      // pts_hst_pro->i_not = NOT_MIN;
      dir_sui();
      return;
    }
  mvt_pio(0);
}

void mvt_pio 		(int i_pri_pas)
{
  /* si i_pri_pas = 1 alors controle suppementaire sur deemasquage par piece prise */	
  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife a nouveau echec */
      /* 		par piece principale pro precedente ? */
      /* 	ou	par piece secondaire pro precedente ? */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)


	  )
	 )

	{
	  /* echec donc mvt impossible */
	  //  pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;
	}

    }
  else  	/* pas d'echec prof precedente */
    {
      /* Verifie echec propre camp par demasquage  */
      if
	(
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)
	 )
	{
	  /* echec donc mvt impossible */
	  // pts_hst_pro->i_not = NOT_MIN;
	  dir_sui();
	  return;
	}
      else     /* pas d'echec */
	{	               		  
	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }
  /* maj cpt de coup pour le niveau (raz mvt ini) */
  pts_hst_pro->uli_cpt_cou++;

  /* verifie si cause echec camp adverse */
  /* par mvt piece principale ou par demasquage*/
  /* ou demasquage du a la piece prise */
  if (i_pro_sim_act < i_pro_sim_max_inf)
    {
 
      if
	(
	 (*pts_pie->pf_ech_par)
	 ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)

	 ||
	 (
	  i_pri_pas
	  &&
	  /* recupere position de la piece prise en passant */
	  /* puis veerifie si echec en calculant la direction */
	  /* de la piece prise vers le roi */

	  (*tpf_cas_ctl 
	   [
	    ech_cal_dir_dem_2 
	    (
	     pts_hst_pro->i_cam_adv,
	     (pts_hst_pro->pts_pie_ca + pts_hst_pro->i_Id_2p)->i_pos_n
	     )
	    ]
	   )
	  (pts_hst_pro->i_pos_n_R_c_a,
	   pts_hst_pro->i_cam)
	  )    
	
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_c_a,
	   pts_hst_pro->i_cam)

	  )
	 )
	{
	  set_ech_on();

	}
      else
	{
	  set_ech_off();
	}
    }

#ifdef STHASH  
    if(pts_hst_pro->pf_hash_add_lx != NULL)
    if( (*pts_hst_pro->pf_hash_add_lx)(pst_hash1))
  	return;
#else
#ifdef STHASH1  
  int i;
  for (i=0;i<=pts_hst_pro->i_nbr_ele_tpf_hash;i++)
 
      if( (*pts_hst_pro->tpf_hash_add[i])(tpst_hash[pts_hst_pro->ti_arg_fct_hash_add[i]]))
  	return;
#else
#endif
#endif

  if
    (
     //mvt_pio
     i_pro_sim_act<i_pro_sim_max_sup
     ||
     (
      (
       //(!pts_hst_pro->defv_ene) 
       //||
       ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
       ||
       pts_hst_pro->defv_ech
       )
      //&&
      //abs(pts_hst_pro->i_rap_for)<RAP_FOR_LIM_CUT
      &&
      i_pro_sim_act<i_pro_sim_max_inf
      )
     )

    {
      /* descendre ds l'arborescence */
      pro_sui();
      /* recopie valeur grd et petit rock pour cam propre */
      cop_val_prc_pc();
      cop_val_grc_pc();
		
      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_prc_ca();
      cop_val_grc_ca();
		
    }
  else
    {
      maj_not_max_at_leaf();
#ifdef ALPHA_BETA_CUT
      if (alpha_beta_cut()) return;
#endif	  

      /* direction suivante meme pro */
      dir_sui();
      return;
    }
}
void maj_not_max_at_leaf(void)
{
  pts_hst_pro->i_not_max_typ_mvt_pri_lea= 
    ti_typ_mvt_pri[ pts_hst_pro->i_typ_mvt ] || pts_hst_pro->i_not_max_typ_mvt_pri_lea ;

  if( pts_hst_pro->i_not > pts_hst_pro->i_not_max )
      maj_not_max();
  else
  if( pts_hst_pro->i_not ==  pts_hst_pro->i_not_max )
    {
      if( pts_hst_pro->i_not_cost < pts_hst_pro->i_not_max_cost )
	  maj_not_max();
      else
      if( pts_hst_pro->i_not_cost == pts_hst_pro->i_not_max_cost )
	{
	  if( pts_hst_pro->i_not_pos >  pts_hst_pro->i_not_max_pos )
	    maj_not_max();
	}
    }
}
void maj_not_max (void)
{
      pts_hst_pro->i_not_max = pts_hst_pro->i_not ;
      pts_hst_pro->i_not_max_cost = pts_hst_pro->i_not_cost ;
      pts_hst_pro->i_not_max_pos = pts_hst_pro->i_not_pos ;

#ifdef UPLOAD_BRANCHE  

      bra_add_nod_max_inf(&pts_hst_pro->pst_not_max_bra_hea,
			  &pts_hst_pro->pst_not_max_bra_las,
			  (char *)&(pts_hst_pro->i_pos_ori_n),
			  (char *)&(pts_hst_pro->i_pos_n),
			  (char *)&(pts_hst_pro->i_typ_mvt)
			  ); 
#endif	  

}

/* Intialisation hst_pro */
void pro_sui 	(void)
{
  i_pro_sim_act++;

  /* initialisation du  pionteurs sur hst */
  /* optimisation: un simple increment serait-il possible */

  //  pts_hst_pro = &ts_hst_pro[i_pro_sim_act];
  //pts_hst_pro_p = &ts_hst_pro[i_pro_sim_act-1];
  pts_hst_pro++;
  pts_hst_pro_p++;
  /*  */
# if CPT_ITE == 1
  pts_hst_pro->cpt = cpt;
# endif
#ifdef STHASH1
  /* init memory for the hash used at this level */
  if (pts_hst_pro->i_mem_hash_nbr >=0)
    {
    ini_mem(&tpst_hash[pts_hst_pro->i_mem_hash_nbr],0,0);
    //printf("\nini mem pro_sim_act %i sthash %i",i_pro_sim_act,pts_hst_pro->i_mem_hash_nbr);
    }
#endif
#ifdef UPLOAD_BRANCHE
  pts_hst_pro->pst_not_max_bra_hea = NULL;
  pts_hst_pro->pst_not_max_bra_las = NULL;
  
#endif

#ifdef ALPHA_BETA_CUT
     pts_hst_pro->defv_alpha_beta_cut = FALSE;
#endif 
  /* puique aucun mouvement n'a eetee efectuee  */
  /* opti est-ce necessaire */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;

  /* descente et maj du rapport de force */
  if(ti_typ_mvt_pri[pts_hst_pro_p->i_typ_mvt])
      pts_hst_pro->i_rap_for = -(pts_hst_pro_p->i_rap_for
				 +
				 pts_pie_pri->i_for
				 // pts_hst_pro_p->i_not
				 );
  else
    pts_hst_pro->i_rap_for = -pts_hst_pro_p->i_rap_for;

  /* raz  du compteur de prise par une piece */
  pts_hst_pro->i_nbr_pri_pie = 0;
  /* initialisation hst avec pos roi camp propre et adverse */
  hst_pos_roi(); 

  /* initialisation du  pionteurs piece actuelle sur 0 */
  pts_pie =
    /*tpts_pie[pts_hst_pro->i_cam];*/
    pts_hst_pro->pts_pie_pc;

  /* initialisation du  pionteurs piece suivante   */
  pts_pie_sui = 
    /*	tpts_pie[pts_hst_pro->i_cam]+pts_pie->i_pie_sui;*/
    pts_pie +pts_pie->i_pie_sui;


  /* chargement historique  avec piece */
  /* optimisation: a revoir, simplifier */
  pts_hst_pro->i_Id		= pts_pie->i_pie_sui;
  pts_hst_pro->i_pos_n		= pts_pie_sui->i_pos_n;
  pts_hst_pro->i_pos_ori_n	= pts_pie_sui->i_pos_n;
  pts_hst_pro->defv_dir_sui  	= pts_pie_sui->defv_mvt_uni_dir;


  /* initialisation du  pionteurs piece actuelle  */
  pts_pie =
    pts_pie+pts_hst_pro->i_Id;

 /* load the note position table for the piece according 
     to the situation ( game depth )*/
  load_not_pos_tbl ( i_pro_sim_act );

  /* initialisation pointeur sur fct mvt ds hst */
  (*pts_pie->pf_ini_hst_mvt)();

  /* raz not_max */
  pts_hst_pro->i_not_max			= NOT_MIN;
  pts_hst_pro->i_not	   		        = NOT_MIN;

  pts_hst_pro->i_not_max_cost			= NOT_MIN;
  pts_hst_pro->i_not_cost   		        = NOT_MIN;

  pts_hst_pro->i_not_max_pos			= NOT_MIN;
  pts_hst_pro->i_not_pos   		        = NOT_MIN;

  pts_hst_pro->i_not_max_typ_mvt_pri_lea	= 0;
  pts_hst_pro->i_typ_mvt_pri_lea	        = 0;

  /* calcul echec par demasquage sur roi camp adverse */
  ech_cal_dir_dem_ca();

  /* calcul echec par demasquage sur roi propre camp   */
  ech_cal_dir_dem_pc();

  return;
}
/* initialisation hst avec pointeur sur tableau de fct mvt */
void ini_hst_mvt_roi(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_roi[pts_hst_pro->i_pos_ori_n];
}
void ini_hst_mvt_rei(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_rei[pts_hst_pro->i_pos_ori_n];

}
void ini_hst_mvt_fou(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_fou[pts_hst_pro->i_pos_ori_n];

}
void ini_hst_mvt_tou(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_tou[pts_hst_pro->i_pos_ori_n];

}
void ini_hst_mvt_cav(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_cav[pts_hst_pro->i_pos_ori_n];
}
void ini_hst_mvt_pio_0(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_pio_0[pts_hst_pro->i_pos_ori_n];
}
void ini_hst_mvt_pio_1(void)
{
  pts_hst_pro->ptpf_mvt=
    ptpf_mvt_pio_1[pts_hst_pro->i_pos_ori_n];
}

/* Direction suivante */
void dir_sui 	(void)
{
  /* restore la position d'origine */
  pts_hst_pro->i_pos_n= pts_hst_pro->i_pos_ori_n;
  /* direction suivante */
  pts_hst_pro->ptpf_mvt++;

}
void pie_sui_maj_not_max_sub (void)
{
  pts_hst_pro_p->i_not_max      = pts_hst_pro_p->i_not;
  pts_hst_pro_p->i_not_max_pos  = pts_hst_pro_p->i_not_pos;
  pts_hst_pro_p->i_not_max_cost = pts_hst_pro_p->i_not_cost;
  #ifdef UPLOAD_BRANCHE  
  pie_sui_bra_add_nod ();
  #endif

}
void pie_sui_upl_not_max (void)
{
  /* if somting is modified here do not forget to see sim_add_l3 */
  /* oranization: only one function */
  if  (abs(pts_hst_pro->i_not_max) > NOT_MAT_MIN)
    {

      pts_hst_pro_p->i_not        =	-pts_hst_pro->i_not_max;
      pts_hst_pro_p->i_not_cost  +=	pts_hst_pro->i_not_max_cost;
      pts_hst_pro_p->i_not_pos    =	-pts_hst_pro->i_not_max_pos;
      /* best movz is a mat: not a taken  */
      pts_hst_pro_p->i_typ_mvt_pri_lea = 0;
    }

  else
    {
	  pts_hst_pro_p->i_not             -=   pts_hst_pro->i_not_max;
	  pts_hst_pro_p->i_not_cost        +=   pts_hst_pro->i_not_max_cost;
	  //	  pts_hst_pro_p->i_not_pos         -=  pts_hst_pro->i_not_max_pos;
	  pts_hst_pro_p->i_not_pos         -=  (
						pts_hst_pro->i_not_max_pos
						/  
						(i_pro_sim_act - i_pro_act)
						);
	  pts_hst_pro_p->i_typ_mvt_pri_lea  =   pts_hst_pro->i_not_max_typ_mvt_pri_lea;
			      
    }

}
void pie_sui_upl_not_max_sv (void)
{
  /* if somting is modified here do not forget to see sim_add_l3 */
  /* oranization: only one function */
  if  (abs(pts_hst_pro->i_not_max) > NOT_MAT_MIN)
    {

      pts_hst_pro_p->i_not        =	-pts_hst_pro->i_not_max;
      pts_hst_pro_p->i_not_cost  +=	pts_hst_pro->i_not_max_cost;
      pts_hst_pro_p->i_not_pos    =	-pts_hst_pro->i_not_max_pos;
      /* best movz is a mat: not a taken  */
      pts_hst_pro_p->i_typ_mvt_pri_lea = 0;
    }

  else
    {
      if(ti_typ_mvt_pri[pts_hst_pro_p->i_typ_mvt])
	{
	  pts_hst_pro_p->i_typ_mvt_pri_lea  =   pts_hst_pro->i_not_max_typ_mvt_pri_lea;
	  pts_hst_pro_p->i_not             -=   pts_hst_pro->i_not_max;
	  pts_hst_pro_p->i_not_cost        +=   pts_hst_pro->i_not_max_cost;
	  pts_hst_pro_p->i_not_pos         -=  pts_hst_pro->i_not_max_pos;
			      
	}
      else
	{
	  pts_hst_pro_p->i_typ_mvt_pri_lea= 0;
	  if ( ! pts_hst_pro->i_not_max_typ_mvt_pri_lea )
	    {
	      pts_hst_pro_p->i_not       -=	  pts_hst_pro->i_not_max;
	      pts_hst_pro_p->i_not_cost  +=	  pts_hst_pro->i_not_max_cost;
	      pts_hst_pro_p->i_not_pos   -=	  pts_hst_pro->i_not_max_pos;

	    }
	}
    }

}
void pie_sui_maj_not_max (void)
{
  if(pts_hst_pro_p->i_not > pts_hst_pro_p->i_not_max)  
    { 
      pie_sui_maj_not_max_sub ();
      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea = pts_hst_pro_p->i_typ_mvt_pri_lea;
    }
  else
    {
      if(pts_hst_pro_p->i_not ==  pts_hst_pro_p->i_not_max)
	{
	  if(pts_hst_pro_p->i_not_pos >  pts_hst_pro_p->i_not_max_pos)
	    {
	      pie_sui_maj_not_max_sub ();
	      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea = pts_hst_pro_p->i_typ_mvt_pri_lea;
	    }
	  else
	    {
	      if(pts_hst_pro_p->i_not_pos ==   pts_hst_pro_p->i_not_max_pos)
		{
		  if(pts_hst_pro_p->i_not_cost >  pts_hst_pro_p->i_not_max_cost)
		    {
		      pie_sui_maj_not_max_sub ();
		      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea = pts_hst_pro_p->i_typ_mvt_pri_lea;

		    }
		  else 
		    {
#ifdef UPLOAD_BRANCHE  
		      pie_sui_bra_rem_nod ();
#endif
		    }
		}
	      else
		{
#ifdef UPLOAD_BRANCHE  
		  pie_sui_bra_rem_nod ();
#endif
		}
	    }
	}
      else
	{
#ifdef UPLOAD_BRANCHE  
	  pie_sui_bra_rem_nod ();
#endif
	}
    }

}
void pie_sui_maj_not_max_cost_not_sv (void)
{
  if(pts_hst_pro_p->i_not > pts_hst_pro_p->i_not_max)  
    { 
      pie_sui_maj_not_max_sub ();
      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea = pts_hst_pro_p->i_typ_mvt_pri_lea;
    }
  else
    {
      if(pts_hst_pro_p->i_not ==  pts_hst_pro_p->i_not_max)
	{
	  if(pts_hst_pro_p->i_not_cost <  pts_hst_pro_p->i_not_max_cost)
	    {
	      pie_sui_maj_not_max_sub ();
	      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea = pts_hst_pro_p->i_typ_mvt_pri_lea;
	    }
	  else
	    {
	      if(pts_hst_pro_p->i_not_cost ==   pts_hst_pro_p->i_not_max_cost)
		{
		  if(pts_hst_pro_p->i_not_pos >  pts_hst_pro_p->i_not_max_pos)
		    {
		      pie_sui_maj_not_max_sub ();
		      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea = pts_hst_pro_p->i_typ_mvt_pri_lea;

		    }
		  else 
		    {
#ifdef UPLOAD_BRANCHE  
		      pie_sui_bra_rem_nod ();
#endif
		    }
		}
	      else
		{
#ifdef UPLOAD_BRANCHE  
		  pie_sui_bra_rem_nod ();
#endif
		}
	    }
	}
      else
	{
#ifdef UPLOAD_BRANCHE  
	  pie_sui_bra_rem_nod ();
#endif
	}
    }

}
void pie_sui_maj_not_max_sv (void)
{
  if( pts_hst_pro_p->i_not_max_typ_mvt_pri_lea)
    {
      if(pts_hst_pro_p->i_typ_mvt_pri_lea)
	{
	  // both result are relatively unshure (taken at leaf)
	  if(pts_hst_pro_p->i_not > pts_hst_pro_p->i_not_max)   
	    pie_sui_maj_not_max_sub ();
	  else
	    if(pts_hst_pro_p->i_not ==  pts_hst_pro_p->i_not_max)
	      if(pts_hst_pro_p->i_not_cost <  pts_hst_pro_p->i_not_max_cost)
		pie_sui_maj_not_max_sub ();
	      else
		if(pts_hst_pro_p->i_not_cost ==   pts_hst_pro_p->i_not_max_cost)
		  if(pts_hst_pro_p->i_not_pos >  pts_hst_pro_p->i_not_max_pos)
		    pie_sui_maj_not_max_sub ();
		  else 
		    {
#ifdef UPLOAD_BRANCHE  
		      pie_sui_bra_rem_nod ();
#endif
		    }
		else
		  {
#ifdef UPLOAD_BRANCHE  
		    pie_sui_bra_rem_nod ();
#endif
		  }
	    else
	      {
#ifdef UPLOAD_BRANCHE  
		pie_sui_bra_rem_nod ();
#endif
	      }
	}
      else
	{
	  // current result is more secure than the max recorded
	  pts_hst_pro_p->i_not_max_typ_mvt_pri_lea= 0;
	  pie_sui_maj_not_max_sub ();
	}
    }
  else
    {
      if( ! pts_hst_pro_p->i_typ_mvt_pri_lea)
	{
	  // both result (current and max) are secure
	  if(pts_hst_pro_p->i_not > pts_hst_pro_p->i_not_max)
	    {
	      pie_sui_maj_not_max_sub ();
	    }
	  else
	    if(pts_hst_pro_p->i_not ==  pts_hst_pro_p->i_not_max)
	      if(pts_hst_pro_p->i_not_cost <  pts_hst_pro_p->i_not_max_cost)
		pie_sui_maj_not_max_sub ();
	      else
		if(pts_hst_pro_p->i_not_cost ==   pts_hst_pro_p->i_not_max_cost)
		  if(pts_hst_pro_p->i_not_pos >  pts_hst_pro_p->i_not_max_pos)
		    pie_sui_maj_not_max_sub ();
		  else 
		    {
#ifdef UPLOAD_BRANCHE  
		      pie_sui_bra_rem_nod ();
#endif
		    }
		else
		  {
#ifdef UPLOAD_BRANCHE  
		    pie_sui_bra_rem_nod ();
#endif
		  }
	    else
	      {
#ifdef UPLOAD_BRANCHE  
		pie_sui_bra_rem_nod ();
#endif
	      }

	}
      else
	{
	  // not max is more secure than current 
	  if (  pts_hst_pro_p->i_not_max == NOT_MIN )
	    {
	      pie_sui_maj_not_max_sub ();
	      pts_hst_pro_p->i_not_max_typ_mvt_pri_lea= 1;
	    }
	  else
	    {
#ifdef UPLOAD_BRANCHE  
	      pie_sui_bra_rem_nod ();
#endif	  
	    }
	}
    }
}

/* Recherche de la piece suivante */
/* dir_sui pas executer si plusieurs mvt par dir */
void pie_sui 	(void)
{
  /* increement du nombre de fourchettes */
  if(pts_hst_pro->i_nbr_pri_pie>2)
    pts_hst_pro->uli_nbr_fou ++;
  pts_hst_pro->i_nbr_pri_pie  =0;

  /* restore toutes les pieces  */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();

  /* tst */
  /*
    if (pts_hst_pro->i_pro== 1)
    {
    printf("\n pro: %i cpt: %i", pts_hst_pro->i_pro,i_not_cpt_mvt_ini);
    aff_ech(0);
    getchar();
    }
  */
  /* puisque les piece on eetee completement  restoreees  */
  pts_hst_pro->i_typ_mvt = PAS_DE_MVT;


  /* reinitalise pointeur piece */
  /* optimisation : is it usefull? */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* si derniere piece */
#ifdef ALPHA_BETA_CUT
 if  (pts_pie->i_pie_sui == 17 || pts_hst_pro->defv_alpha_beta_cut )
#else
  if  (pts_pie->i_pie_sui == 17)
#endif
    {
      /* opti : dans la plus part des cas il n'y a pas pat ou mat */ 
      /* calcule de la note   */
      if(pts_hst_pro_p->defv_mat)
	{

	  pts_hst_pro_p->i_not             = NOT_MAT - pts_hst_pro_p->i_dec_mat;
	  pts_hst_pro_p->i_not_cost        = 0;
	  pts_hst_pro_p->i_not_pos         = 0;
	  pts_hst_pro_p->i_typ_mvt_pri_lea = 0;

	  if( pts_hst_pro_p->i_rap_for >= 0 )
	    pts_hst_pro_p->uli_cpt_mat_rf ++;
	  pts_hst_pro_p->uli_cpt_mat++;
	}

      else
	{
	  if( pts_hst_pro_p->defv_pat )
	    {

	      /* fct : ca serait bien de prendre en compte */
	      /* rapport de force pour moduler la note pat */
	      /* soit en recalculant ce rapport pendant la simu */
	      /* ou simplement en iniitalisant une variable */
	      /* globale juste avant la simulation */
	      pts_hst_pro_p->i_not              =0;	
	      pts_hst_pro_p->i_not_cost        = 0;
	      pts_hst_pro_p->i_not_pos         = 0;
	      pts_hst_pro_p->i_typ_mvt_pri_lea = 0;
	  
	      if( pts_hst_pro_p->i_rap_for >= 0 )			       
		pts_hst_pro_p->uli_cpt_pat_rf++;
	      pts_hst_pro_p->uli_cpt_pat++;
	    }
	  else
	    {
	      pie_sui_upl_not_max ();
	    }
	}

      /* store the result (i_not) in the has table */
#ifdef STHASH  
      if(i_pro_sim_act == i_pro_act+4)
	sto_res(pst_hash1);
#endif
#ifdef STHASH1  
  /* store result for the hash used at this level */
  if (pts_hst_pro->i_sto_res_hash_nbr >=0)
    sto_res(tpst_hash[pts_hst_pro->i_sto_res_hash_nbr]);
  /* free memory for the hash created  at this level */
  if (pts_hst_pro->i_mem_hash_nbr >=0)
    {
      fre_mem(&tpst_hash[pts_hst_pro->i_mem_hash_nbr]);
      //printf("\n fre_mem pro_sim_act: %i sthash %i",i_pro_sim_act,pts_hst_pro->i_mem_hash_nbr);

    }
#endif

  pie_sui_maj_not_max ();

  if (i_pro_sim_act == i_pro_act+1)
	{
	  /* fin de simulation  */
	  defv_sim_end = STOP ;
	  return;
	}
      else
	{
	  /* calcul de la note pour pro =1 */
	  if (i_pro_sim_act == i_pro_act+2)
	    {
#ifdef UPLOAD_BRANCHE  
	      //	      bra_prt_lst(pts_hst_pro_p->pst_not_max_bra_hea);
#endif

	      // what should be done:
	      // pointer on st_evaluation  in st_simu (that has a pointe on hst_pro)
	      // pst_sim->pst_evaluation->import_data(pst_simu->pst_hst_pro);
	      if(pf_not_cal != NULL) (*pf_not_cal)();
	      i_not_cpt_mvt_ini++; 
	    }

	  i_pro_sim_act--;

	  /* optimisatio pts_hst_pro -- */
	  /* initialisation du  pionteurs sur hst */
	  //	  pts_hst_pro 	= &ts_hst_pro[i_pro_sim_act];
	  //pts_hst_pro_p 	= &ts_hst_pro[i_pro_sim_act-1];
	  pts_hst_pro--;
	  pts_hst_pro_p--;

	  /* initialisation du  pionteurs piece actuelle  */
	  /*pts_pie = tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;*/
	  pts_pie = pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

#ifdef ALPHA_BETA_CUT
	  if ( alpha_beta_cut() )
	      return;
#endif
	  
	  /* direction suivante seulement pour piece ayant un mvt par dir */
	  if(pts_hst_pro->defv_dir_sui)		dir_sui();
	 
	}
    }
  else    /* si pas derniere piece */
    {

      /* chargement historique avec piece suivante */
      pts_hst_pro->i_Id			= pts_pie->i_pie_sui;
      /* initialisation du pionteurs piece */
      /* optimisation should used pointer instead of index */
      pts_pie =
	pts_hst_pro->pts_pie_pc + pts_pie->i_pie_sui;

      pts_hst_pro->i_pos_n	= pts_pie->i_pos_n;
      pts_hst_pro->i_pos_ori_n	= pts_pie->i_pos_n;
      pts_hst_pro->defv_dir_sui  	= pts_pie->defv_mvt_uni_dir;

      /* load the note position table for the piece according 
	 to the situation ( game depth )*/
      load_not_pos_tbl ( i_pro_sim_act );


      /* initialisation pointeur sur fct mvt ds hst */
      (*pts_pie->pf_ini_hst_mvt)();

      /* calcul echec par demasquage sur roi camp adverse */
      ech_cal_dir_dem_ca();
      /* calcul echec par demasquage sur roi propre camp   */
      ech_cal_dir_dem_pc();
    }
}
#ifdef UPLOAD_BRANCHE  

void pie_sui_bra_add_nod (void)
{
  if(i_pro_sim_act == i_pro_act+3)
    {
      bra_add_nod_lea(&pts_hst_pro_p->pst_not_max_bra_hea,
		      &pts_hst_pro->pst_not_max_bra_hea,
		      &pts_hst_pro_p->pst_not_max_bra_las,
		      &pts_hst_pro->pst_not_max_bra_las,
		      (char *)&(pts_hst_pro_p->i_pos_ori_n),
		      (char *)&(pts_hst_pro_p->i_pos_n),
		      (char *)&(pts_hst_pro_p->i_typ_mvt) ); 
    }
  else
    {
      if(i_pro_sim_act > i_pro_act+3)
	bra_add_nod(&pts_hst_pro_p->pst_not_max_bra_hea,
		    &pts_hst_pro->pst_not_max_bra_hea,
		    &pts_hst_pro_p->pst_not_max_bra_las,
		    &pts_hst_pro->pst_not_max_bra_las,
		    (char *)&(pts_hst_pro_p->i_pos_ori_n),
		    (char *)&(pts_hst_pro_p->i_pos_n),
		    (char *)&(pts_hst_pro_p->i_typ_mvt) ); 
    }
}
void pie_sui_bra_rem_nod (void)
{
  if(i_pro_sim_act > i_pro_act+3)
    bra_rem_nod(&pts_hst_pro->pst_not_max_bra_hea,
		&pts_hst_pro_p->pst_not_max_bra_las,
		&pts_hst_pro->pst_not_max_bra_las
		); 
}
#endif

#ifdef ALPHA_BETA_CUT
int alpha_beta_cut 	(void)
{
   if(
      i_pro_sim_act > i_pro_act+ i_alpha_beta_min_depth
      &&
      pts_hst_pro_p->i_not - pts_hst_pro->i_not  < pts_hst_pro_p->i_not_max 
      )
    {
      /* in the next simu loop the pie_sui() will be called instead
	 of one of the actual array 
      */ 
      pts_hst_pro->ptpf_mvt=
	tpf_alpha_beta_cut; 
      /* when nex piece is called it must behave as if we had reached
	 the las piece */
      pts_hst_pro->defv_alpha_beta_cut = TRUE;
  
      return TRUE;
    }
   else
     {
       pts_hst_pro->defv_alpha_beta_cut = FALSE;
       return FALSE;
     }

}
/*
void do_cut 	(void)
{
  // in the next simu loop the pie_sui() will be called instead
  //   of one of the actual array 
  
  pts_hst_pro->ptpf_mvt=
    tpf_alpha_beta_cut; 
  // when nex piece is called it must behave as if we had reached
  //   the las piece 
  pts_hst_pro->defv_alpha_beta_cut = TRUE;
  

}
*/
#endif
/* Copie val petit/grand rock  pour propre camp */
void cop_val_prc_pc (void)
{
  pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]=
    pts_hst_pro_p->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC];

}
void cop_val_grc_pc (void)
{
  pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]=
    pts_hst_pro_p->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC] ;

}

/* Copie val petit/grand rock  camp adverse */
void cop_val_prc_ca (void)
{
  pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][PET_ROC]=
    pts_hst_pro_p->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][PET_ROC];

}
void cop_val_grc_ca (void)
{
  pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][GRA_ROC]=
    pts_hst_pro_p->
    ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][GRA_ROC] ;

}

/* chargement hst avec position roi camp propre et adverse  */
/* opti: faire une fonction par camp ?*/
void hst_pos_roi 	(void)
{
  /* initialisation du ptr et memorisation position roi propre camp */
  pts_hst_pro->i_pos_n_R_p_c= (pts_hst_pro->pts_pie_pc + Id_roi[pts_hst_pro->i_cam])->i_pos_n;

  /* initialisation du ptr et memorisation position roi camp adverse */
  pts_hst_pro->i_pos_n_R_c_a= (pts_hst_pro->pts_pie_ca + Id_roi[pts_hst_pro->i_cam_adv])->i_pos_n;	
}
/* deprecated  */
//void maj_not (void)
//{
  
// /* Si le bilan n'est pas nul on prend la note normale */
//  if ((pts_hst_pro->i_rap_for + pts_pie_pri->i_for)!=0  )
//    {
//      pts_hst_pro->i_not = pts_pie_pri->i_for;
//    }
//  else
//    /* si le bilan est nul alors sa ne sert a rien de provoquer une eequatombe 
//       puisqu'il n'y a aucun gain  */
//    {
//      /* Si ennemi */
//      if (pts_hst_pro->defv_ene)
//	pts_hst_pro->i_not = pts_pie_pri->i_for + 1 ;  
//      else
//	pts_hst_pro->i_not = pts_pie_pri->i_for - 1 ;  

//    }
//}	
void maj_not_pos (void)
{
  /* note the piece position for this move  */
  if (pts_hst_pro->i_cam == BLANC)
    pts_hst_pro->i_not_pos =  pts_pie->ptdef_not_pos_pie [ pts_hst_pro->i_pos_n]
                              -
                              pts_pie->ptdef_not_pos_pie [ pts_hst_pro->i_pos_ori_n];
  else
    /* for black the table is reversed  A1 -> H8 A2 -> H7 ect .. */
    pts_hst_pro->i_not_pos =  pts_pie->ptdef_not_pos_pie [(99-pts_hst_pro->i_pos_n)]
                              -
                              pts_pie->ptdef_not_pos_pie [ pts_hst_pro->i_pos_ori_n];

}
void maj_not_pos_pri (void)
{
  maj_not_pos();
  /* add the note the piece taken  */
  if (pts_hst_pro->i_cam == NOIR)
    pts_hst_pro->i_not_pos +=  pts_pie_pri->ptdef_not_pos_pie [ pts_hst_pro->i_pos_n];
  else
    /* for black the table is reversed  A1 -> H8 A2 -> H7 ect .. */
    pts_hst_pro->i_not_pos +=  pts_pie_pri->ptdef_not_pos_pie [(99-pts_hst_pro->i_pos_n)];

}
void maj_not_pos_sv (void)
{
  /* note the piece position for this move  */
  if (pts_hst_pro->i_cam == BLANC)
    pts_hst_pro->i_not_pos =  pts_pie->ptdef_not_pos_pie [ pts_hst_pro->i_pos_n];
  else
    /* for black the table is reversed  A1 -> H8 A2 -> H7 ect .. */
    pts_hst_pro->i_not_pos =  pts_pie->ptdef_not_pos_pie [(99-pts_hst_pro->i_pos_n)];

}
void maj_not_pri (void)
{
  pts_hst_pro->i_not      = pts_pie_pri->i_for;
  pts_hst_pro->i_not_cost =  pts_hst_pro->i_not;
  maj_not_pos_pri ();
}
void maj_not_pri_sv (void)
{
  /* inc */
  /* Si le bilan n'est pas nul on prend la note normale */
  if ((pts_hst_pro->i_rap_for + pts_pie_pri->i_for)!=0  )
    {
      pts_hst_pro->i_not = pts_pie_pri->i_for;
    }
  else
    /* si le bilan est nul alors sa ne sert a rien de provoquer une eequatombe 
       puisqu'il n'y a aucun gain  */
    {
      /* Si ennemi */
      if (pts_hst_pro->defv_ene==Y)
	pts_hst_pro->i_not = pts_pie_pri->i_for + INC_PRI_NUL ;  
      else
	pts_hst_pro->i_not = pts_pie_pri->i_for - INC_PRI_NUL ;  

    }
  maj_not_pos ();
}
		
void maj_not_dep (void)
{
  /* when deplacing only a piece (no taking)         */

   pts_hst_pro->i_not      = 0;
   pts_hst_pro->i_not_cost  = 0;
   maj_not_pos ();

}	
/* fonction de deplacement simple piece(s) */
void dep_sim()
{
  pts_pie = pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime piece de son emplacement dans echiquier */
  ts_ech[pts_pie ->i_pos_n].i_cam 	= VIDE;
  ts_ech[pts_pie ->i_pos_n].i_Id   	= VIDE;

  /* modifie place dans piece */
  pts_pie ->i_pos_n= pts_hst_pro->i_pos_n;
	
  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[pts_hst_pro->i_pos_n].i_cam = pts_hst_pro->i_cam;
  ts_ech[pts_hst_pro->i_pos_n].i_Id = pts_hst_pro->i_Id;

  /* update the mark (note) */
  maj_not_dep ();

}
/* fontion de deplacement avec simple prise de pieces */
/* optimisation certains pointeur inutiles */
void pri_sim()
{
#ifdef TEST_SIMU
  if (ts_ech[pts_hst_pro ->i_pos_n].i_Id==Id_roi[pts_hst_pro->i_cam_adv] )
    {	
#if CPT_ITE == 1
      printf("\n Err Pgm Roi pris pro: %i mvt ini %i cpt_ite: %lu",
	     i_not_cpt_mvt_ini,
	     pts_hst_pro->i_pro,cpt);
#else
      printf("\n Err Pgm Roi pris pro: %i mvt ini %i ",
	     i_not_cpt_mvt_ini,
	     pts_hst_pro->i_pro);
  
#endif
      aff_ech(0);
      aff_hst(0,0);
      getchar();
      sav_dsk("ec.bug");
    }
#endif

  /* reinitalise pointeur piece */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime piece principale de son anciene place dans echiquier */
  ts_ech[pts_pie ->i_pos_n].i_cam 	= VIDE;
  ts_ech[pts_pie ->i_pos_n].i_Id 	= VIDE;

  /* modifie sa place dans piece */
  pts_pie ->i_pos_n= pts_hst_pro->i_pos_n;
	
  /* memorisation Id de la piece prise */
  pts_hst_pro->i_Id_2p =
    ts_ech[pts_hst_pro->i_pos_n].i_Id;

  /* ajoute a sa nouvelle place dans echiquier (piece prise effaceee) */
  ts_ech[pts_hst_pro->i_pos_n].i_cam = pts_hst_pro->i_cam;
  ts_ech[pts_hst_pro->i_pos_n].i_Id = pts_hst_pro->i_Id;

  /* initailisation des pionteurs sur pie */
  /* piece prise */
  pts_pie_pri 	= pts_hst_pro->pts_pie_ca + pts_hst_pro->i_Id_2p;
  pts_pie_sui_pri = pts_hst_pro->pts_pie_ca +pts_pie_pri->i_pie_sui;
  pts_pie_pre_pri = pts_hst_pro->pts_pie_ca +pts_pie_pri->i_pie_pre;

  /* suppression piece prise dans piece */
  pts_pie_pre_pri->i_pie_sui = pts_pie_pri->i_pie_sui;
  pts_pie_sui_pri->i_pie_pre = pts_pie_pri->i_pie_pre;

  /* maj note dans hst */
  maj_not_pri();



}
void pri_pas()
{
  /* reinitalise pointeur piece */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime piece principale de son anciene place dans echiquier */
  ts_ech[pts_pie ->i_pos_n].i_cam = VIDE;
  ts_ech[pts_pie ->i_pos_n].i_Id  = VIDE;

  /* modifie sa place dans piece */
  pts_pie ->i_pos_n= pts_hst_pro->i_pos_n;

  /* memorisation Id de la piece prise */
  pts_hst_pro->i_Id_2p =
    ts_ech[pts_hst_pro_p->i_pos_n].i_Id;

  /* ajoute a sa nouvelle place dans echiquier (piece prise a effacer) */
  ts_ech[pts_hst_pro->i_pos_n].i_cam = pts_hst_pro->i_cam;
  ts_ech[pts_hst_pro->i_pos_n].i_Id = pts_hst_pro->i_Id;
	
  /* supprime le piece prise de l'echiquier (necessaire dans prise en passant) */
  ts_ech[pts_hst_pro_p->i_pos_n].i_cam = VIDE;
  ts_ech[pts_hst_pro_p->i_pos_n].i_Id  = VIDE;

  /* initailisation des pionteurs sur pie */
  /* piece prise */
  pts_pie_pri 	= pts_hst_pro->pts_pie_ca + pts_hst_pro->i_Id_2p;
  pts_pie_sui_pri = pts_hst_pro->pts_pie_ca +pts_pie_pri->i_pie_sui;
  pts_pie_pre_pri = pts_hst_pro->pts_pie_ca +pts_pie_pri->i_pie_pre;

  /* suppression piece prise dans piece */
  pts_pie_pre_pri->i_pie_sui = pts_pie_pri->i_pie_sui;
  pts_pie_sui_pri->i_pie_pre = pts_pie_pri->i_pie_pre;

  /* maj note dans hst */
  maj_not_pri();

}
/* fonction de deplacement grand rock blanc */
void dep_grd_roc_0()
{
  /* maj note dans hst */
  pts_hst_pro->i_not = NOT_ROC;
  /* reinitalise pointeur piece */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime roi blanc de son emplacement dans echiquier */ 
  ts_ech[E1].i_cam = VIDE;
  ts_ech[E1].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie ->i_pos_n= C1;

  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[C1].i_cam = BLANC;
  ts_ech[C1].i_Id = pts_hst_pro->i_Id;

  /* memorisation Id de la tour grd rock */
  pts_hst_pro->i_Id_2p = ts_ech[A1].i_Id;

  /* suprime tour de son emplacement dans echiquier */
  ts_ech[A1].i_cam = VIDE;
  ts_ech[A1].i_Id  = VIDE;
  /* modifie place dans piece */
  pts_pie_tou_roc = ts_pie_0 +pts_hst_pro->i_Id_2p;
  pts_pie_tou_roc->i_pos_n= D1;
	
  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[D1].i_cam = BLANC;
  ts_ech[D1].i_Id = pts_hst_pro->i_Id_2p;



}
/* fonction de deplacement grand rock noir */
void dep_grd_roc_1()
{
  /* maj note dans hst */
  pts_hst_pro->i_not = NOT_ROC;

  /* reinitalise pointeur piece */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime roi noir de son emplacement dans echiquier */
  ts_ech[E8].i_cam = VIDE;
  ts_ech[E8].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie ->i_pos_n= C8;

  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[C8].i_cam = NOIR;
  ts_ech[C8].i_Id = pts_hst_pro->i_Id;

  /* memorisation Id de la tour grd rock */
  pts_hst_pro->i_Id_2p = ts_ech[A8].i_Id;

  /* suprime tour de son emplacement dans echiquier */
  ts_ech[A8].i_cam = VIDE;
  ts_ech[A8].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie_tou_roc = ts_pie_1 +pts_hst_pro->i_Id_2p;
  pts_pie_tou_roc->i_pos_n= D8;

  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[D8].i_cam = NOIR;
  ts_ech[D8].i_Id = pts_hst_pro->i_Id_2p;	

}
/* fonction de deplacement petit rock blanc */
void dep_pet_roc_0()
{
  /* maj note dans hst */
  pts_hst_pro->i_not = NOT_ROC;

  /* reinitalise pointeur piece */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime roi blanc de son emplacement dans echiquier */
  ts_ech[E1].i_cam = VIDE;
  ts_ech[E1].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie ->i_pos_n= G1;
	
  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[G1].i_cam = BLANC;
  ts_ech[G1].i_Id = pts_hst_pro->i_Id;

  /* memorisation Id de la tour petit rock */
  pts_hst_pro->i_Id_2p = ts_ech[H1].i_Id;

  /* suprime tour de son emplacement dans echiquier */
  ts_ech[H1].i_cam = VIDE;
  ts_ech[H1].i_Id  = VIDE;
  /* modifie place dans piece */
  pts_pie_tou_roc = ts_pie_0 +pts_hst_pro->i_Id_2p;
  pts_pie_tou_roc->i_pos_n= F1;
	
  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[F1].i_cam = BLANC;
  ts_ech[F1].i_Id = pts_hst_pro->i_Id_2p;

}
/* fonction de deplacement petit rock noir */
void dep_pet_roc_1()
{
  /* maj note dans hst */
  pts_hst_pro->i_not = NOT_ROC;

  /* reinitalise pointeur piece */
  pts_pie =pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime roi blanc de son emplacement dans echiquier */
  ts_ech[E8].i_cam = VIDE;
  ts_ech[E8].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie ->i_pos_n= G8;
	
  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[G8].i_cam = NOIR;
  ts_ech[G8].i_Id = pts_hst_pro->i_Id;

  /* memorisation Id de la tour petit rock */
  pts_hst_pro->i_Id_2p = ts_ech[H8].i_Id;

  /* suprime tour de son emplacement dans echiquier */
  ts_ech[H8].i_cam = VIDE;
  ts_ech[H8].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie_tou_roc = ts_pie_1 +pts_hst_pro->i_Id_2p;
  pts_pie_tou_roc->i_pos_n= F8;
	
  /* ajoute a sa nouvelle place dans echiquier */
  ts_ech[F8].i_cam = 1;
  ts_ech[F8].i_Id = pts_hst_pro->i_Id_2p;


}

/* fontion de restauration piece principale position d'origine */
void dep_res()
{
  /* initialise le pointeur piece */
  pts_pie = pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

  /* suprime piece de son emplacement actuel dans echiquier */
  ts_ech[pts_pie ->i_pos_n].i_cam = VIDE;
  ts_ech[pts_pie ->i_pos_n].i_Id  = VIDE;

  /* modifie place dans piece */
  pts_pie ->i_pos_n= pts_hst_pro->i_pos_ori_n;

  /* remet a son ancienne place dans echiquier */
  ts_ech[pts_hst_pro->i_pos_ori_n].i_cam
    = pts_hst_pro->i_cam;
  ts_ech[pts_hst_pro->i_pos_ori_n].i_Id
    = pts_hst_pro->i_Id;
}

/* restore le type de la piece en pion  */
void pio_res_typ(void)
{
  /* le pionteur piece doit etre bien initialisee */
  if (pts_hst_pro->i_cam == BLANC)
    set_pie_pio_blanc();
  else
    set_pie_pio_noir();
}
/* restore position et type du pion promotionee */
void pio_res(void)
{
  /* restore la piece a sa place */
  dep_res();
  /* restore le type de la piece */
  pio_res_typ();

}
/* restore position et type du pion apres prise */
void pri_pio_res(void)
{
  /* restore la piece supprimeee */
  pri_res();
  /* retore le type de la piece */
  pio_res_typ();
}
/* restore position pieces apres prise  */
void pri_res (void)
{
  /* restores de la piece principale */
  dep_res();
  /* restore de la piece prise */
  pie_pri_res();
}

/* restore seulement la  pieces prise  */
void pie_pri_res(void)
{

  /* initailisation des pionteurs sur pie */
  /* piece prise */
  pts_pie_pri 	= pts_hst_pro->pts_pie_ca + pts_hst_pro->i_Id_2p;
  pts_pie_sui_pri = pts_hst_pro->pts_pie_ca + pts_pie_pri->i_pie_sui;
  pts_pie_pre_pri = pts_hst_pro->pts_pie_ca + pts_pie_pri->i_pie_pre;
  /* desuppression piece prise dans piece */
  pts_pie_pre_pri->i_pie_sui = pts_hst_pro->i_Id_2p;
  pts_pie_sui_pri->i_pie_pre = pts_hst_pro->i_Id_2p;

  /* ajoute a son ancienne place dans echiquier */
  ts_ech[pts_pie_pri->i_pos_n].i_cam
    = pts_hst_pro->i_cam_adv;

  ts_ech[pts_pie_pri->i_pos_n].i_Id =
    pts_hst_pro->i_Id_2p;
}
/* restore position des piece apres grd roc */
void gra_roc_res (void)
{
  /* restore la piece principale (roi) */
  dep_res();
  /* restor la tour */
  tou_gra_roc_res();
}

/* restore position de la tour grand rock */
void tou_gra_roc_res(void)
{

  if (pts_hst_pro->i_cam == BLANC)     			/* blanc */
    {
      /* initailisation du pionteurs sur tour */
      pts_pie_tou_roc 	= ts_pie_0+pts_hst_pro->i_Id_2p;

      /* suprime tour de son emplacement dans echiquier */
      ts_ech[D1].i_cam = VIDE;
      ts_ech[D1].i_Id =  VIDE;

      /* modifie place dans piece */
      pts_pie_tou_roc->i_pos_n= A1 ;
	
      /* ajoute a sa nouvelle place dans echiquier */
      ts_ech[A1].i_cam  	= pts_hst_pro->i_cam;
      ts_ech[A1].i_Id    	= pts_hst_pro->i_Id_2p;
    }
  else									/* noir */
    {
      /* initailisation du pionteurs sur tour */
      pts_pie_tou_roc 	= ts_pie_1+pts_hst_pro->i_Id_2p;

      /* suprime piece de son emplacement dans echiquier */
      ts_ech[D8].i_cam = VIDE;
      ts_ech[D8].i_Id =  VIDE;

      /* modifie place dans piece */
      pts_pie_tou_roc->i_pos_n= A8 ;
	
      /* ajoute a sa nouvelle place dans echiquier */
      ts_ech[A8].i_cam  	= pts_hst_pro->i_cam;
      ts_ech[A8].i_Id    	= pts_hst_pro->i_Id_2p;
    }

}
/* resore position des pieces apres  petit roc */
void pet_roc_res(void)
{
  /* restore la piece principale (roi) */
  dep_res();
  /*  restore la tour */
  tou_pet_roc_res();
}
/* restore position de la tour petit rock */
void tou_pet_roc_res(void)
{
	
  if (pts_hst_pro->i_cam == BLANC)     			/* blanc */
    {
      /* initailisation du pionteurs sur tour */
      pts_pie_tou_roc 	= ts_pie_0+pts_hst_pro->i_Id_2p;

      /* suprime tour de son emplacement dans echiquier */
      ts_ech[F1].i_cam = VIDE;
      ts_ech[F1].i_Id =  VIDE;

      /* modifie place dans piece */
      pts_pie_tou_roc->i_pos_n= H1 ;
	
      /* ajoute a sa nouvelle place dans echiquier */
      ts_ech[H1].i_cam  	= pts_hst_pro->i_cam;
      ts_ech[H1].i_Id    	= pts_hst_pro->i_Id_2p;
    }
  else									/* noir */
    {
      /* initailisation du pionteurs sur tour */
      pts_pie_tou_roc 	= ts_pie_1+pts_hst_pro->i_Id_2p;

      /* suprime piece de son emplacement dans echiquier */
      ts_ech[F8].i_cam = VIDE;
      ts_ech[F8].i_Id =  VIDE;

      /* modifie place dans piece */
      pts_pie_tou_roc->i_pos_n= H8 ;
	
      /* ajoute a sa nouvelle place dans echiquier */
      ts_ech[H8].i_cam  	= pts_hst_pro->i_cam;
      ts_ech[H8].i_Id    	= pts_hst_pro->i_Id_2p;
    }

}
/* incremente la note pour le pion transformee en autre piece */
void  inc_for_pio (void)
{
  pts_hst_pro->i_not += pts_pie->i_for;		
}

/* positione flag si echec ou pas echec */
void set_ech_on()
{
  pts_hst_pro->defv_ech = Y;
  pts_hst_pro->defv_mat = Y;
  pts_hst_pro->defv_pat = N;
}
void set_ech_off()
{
  pts_hst_pro->defv_ech = N;
  pts_hst_pro->defv_mat = N;
  pts_hst_pro->defv_pat = Y;
	
}

#if DOS == 1
/*  Gestion interruption clavier */
int get_key(void)
{
  int key, lo , hi;

  key 	= bioskey(0);
  lo 	= key & 0X00FF;
  hi 	= (key &0XFF00)>>8;

  return ((lo==0) ? hi+256:lo);
}
#endif
/* demande d'arret de la simulation */
void sto_sim_set (int i_sig)
{
  if ( i_sig == SIGINT )
    {
      defv_sim_end = _SIGINT;
      return;
    }

  if ( i_sig == SIGTERM )
    {
      defv_sim_end = _SIGTERM;
      return;
    }

}
/* in case of ^C ask to confirm the interruption  */
void sto_sim_int (void)
{
#if DOS == 1

  if(bioskey(1))
    {
      if(get_key ()== ESC)
	sto_sim_msg();
    }
#else
    sto_sim_msg();
#endif

}
/* sto la simulation a la demande */
void sto_sim (void)
{
  i_pro_sim_max_sup = i_pro_act;
  i_pro_sim_max_inf = i_pro_act;
}

#ifdef STHASH1  

int sim_add_l1(struct st_hash *pst_hash)
{
  /* add the data  */
      add_mvt_l1(
		 pst_hash,
		 pts_hst_pro->i_pos_ori_n,
		 pts_hst_pro->i_pos_n,
		 pts_hst_pro->i_typ_mvt
		 );
	return 0; /* do not dive!*/
}
int sim_add_l2(struct st_hash *pst_hash)
{
  /* add the data  */
      add_mvt_l2(
		 pst_hash,
		 pts_hst_pro->i_pos_ori_n,
		 pts_hst_pro->i_pos_n,
		 pts_hst_pro->i_typ_mvt
		 );
	return 0; /* do not dive!*/
}
void  sim_add_l3_upl_not_max(  
			     int i_not,
			     int i_not_cost,
			     int i_not_pos,
			     int i_typ_pri_lea
			    )
{

      /* "uplod of the hash not */
      if (abs(i_not)>NOT_MAT_MIN)
	{
	  pts_hst_pro->i_not               = - i_not;
	  pts_hst_pro->i_not_cost         +=  i_not_cost;
	  pts_hst_pro->i_not_pos          -=  i_not_pos;
	  pts_hst_pro->i_typ_mvt_pri_lea   =0;
	}
      else
	{
	      pts_hst_pro->i_not            -=	i_not;
	      pts_hst_pro->i_not_cost       +=  i_not_cost;
	      pts_hst_pro->i_not_pos        -=  i_not_pos;
	      pts_hst_pro->i_typ_mvt_pri_lea =  i_typ_pri_lea;
			      
	}
 
}
void  sim_add_l3_upl_not_max_sv(  
			     int i_not,
			     int i_not_cost,
			     int i_not_pos,
			     int i_typ_pri_lea
			    )
{

      /* "uplod of the hash not */
      if (abs(i_not)>NOT_MAT_MIN)
	{
	  pts_hst_pro->i_not               = - i_not;
	  pts_hst_pro->i_not_cost         +=  i_not_cost;
	  pts_hst_pro->i_not_pos          -=  i_not_pos;
	  pts_hst_pro->i_typ_mvt_pri_lea   =0;
	}
      else
	{
	  if(ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt])
	    {
	      pts_hst_pro->i_typ_mvt_pri_lea =  i_typ_pri_lea;
	      pts_hst_pro->i_not            -=	i_not;
	      pts_hst_pro->i_not_cost       +=  i_not_cost;
	      pts_hst_pro->i_not_pos        -=  i_not_pos;
			      
	    }
	  else
	    {
	      pts_hst_pro->i_typ_mvt_pri_lea= 0;
	      if ( ! i_typ_pri_lea )
		{
		  pts_hst_pro->i_not            -= i_not;
		  pts_hst_pro->i_not_cost       +=  i_not_cost;
		  pts_hst_pro->i_not_pos        -=  i_not_pos;
		}
	    }

	}
 
}
void sim_add_l3_maj_not_max_sub(void)
{
  pts_hst_pro->i_not_max =pts_hst_pro->i_not;
  pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
  pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
  pts_hst_pro->i_not_max_typ_mvt_pri_lea= pts_hst_pro->i_typ_mvt_pri_lea;
		  
}
void  sim_add_l3_maj_not_max(void)
{
  if( pts_hst_pro->i_not > pts_hst_pro->i_not_max )
    {
      sim_add_l3_maj_not_max_sub();
    }

  else
    {
      if( pts_hst_pro->i_not == pts_hst_pro->i_not_max )
	{
	  if( pts_hst_pro->i_not_pos >  pts_hst_pro->i_not_max_pos )
	  sim_add_l3_maj_not_max_sub();
	}
      else
	{
	  if( pts_hst_pro->i_not_pos ==  pts_hst_pro->i_not_max_pos )
	    if( pts_hst_pro->i_not_cost <  pts_hst_pro->i_not_max_cost )
	      sim_add_l3_maj_not_max_sub();
	  

	}
			
    }


}
void  sim_add_l3_maj_not_max_cost_pos_sv(void)
{
  if(pts_hst_pro->i_not > pts_hst_pro->i_not_max)
    {
      sim_add_l3_maj_not_max_sub();
    }

  else
    {
      if(pts_hst_pro->i_not == pts_hst_pro->i_not_max)
	{
	  if(pts_hst_pro->i_not_cost <  pts_hst_pro->i_not_max_cost)
	  sim_add_l3_maj_not_max_sub();
	}
      else
	{
	  if(pts_hst_pro->i_not_cost ==  pts_hst_pro->i_not_max_cost)
	    if(pts_hst_pro->i_not_pos >  pts_hst_pro->i_not_max_pos)
	      sim_add_l3_maj_not_max_sub();
	  

	}
			
    }


}
void  sim_add_l3_maj_not_max_sv(void)
{
    if( pts_hst_pro->i_not_max_typ_mvt_pri_lea)
	{
	  if(pts_hst_pro->i_typ_mvt_pri_lea)
	    {
	      // both are unshure (taken at leaf )
	      if(pts_hst_pro->i_not > pts_hst_pro->i_not_max)
		{
		  pts_hst_pro->i_not_max =pts_hst_pro->i_not;
		  pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
		  pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
		}
	      else
		{
		  if(pts_hst_pro->i_not == pts_hst_pro->i_not_max)
		    {
		      if(pts_hst_pro->i_not_cost <  pts_hst_pro->i_not_max_cost)
			{
			  pts_hst_pro->i_not_max =pts_hst_pro->i_not;
			  pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
			  pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
			}
		      else
			if(pts_hst_pro->i_not_cost ==  pts_hst_pro->i_not_max_cost)
			  if(pts_hst_pro->i_not_pos >  pts_hst_pro->i_not_max_pos)
			    {
			      pts_hst_pro->i_not_max =pts_hst_pro->i_not;
			      pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
			      pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
			    }  
		    }
		}
	    }
	  else
	    {
	      // not is safer than not_max  
	      pts_hst_pro->i_not_max_typ_mvt_pri_lea= 0;
	      pts_hst_pro->i_not_max =pts_hst_pro_p->i_not;
	      pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
	      pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
	    }
	}
      else
	{
	  // not max is safe 
	  if( ! pts_hst_pro->i_typ_mvt_pri_lea)
	    {
	      // and not is safe too 
	      if(pts_hst_pro->i_not > pts_hst_pro->i_not_max)
		{
		  pts_hst_pro->i_not_max =pts_hst_pro->i_not;
		  pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
		  pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;

		}
	      else
		{
		  if(pts_hst_pro->i_not == pts_hst_pro->i_not_max)
		    {
		      if(pts_hst_pro->i_not_cost <  pts_hst_pro->i_not_max_cost)
			{
			  pts_hst_pro->i_not_max =pts_hst_pro->i_not;
			  pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
			  pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
			}
		      else
			if(pts_hst_pro->i_not_cost ==  pts_hst_pro->i_not_max_cost)
			  if(pts_hst_pro->i_not_pos >  pts_hst_pro->i_not_max_pos)
			    {
			      pts_hst_pro->i_not_max =pts_hst_pro->i_not;
			      pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
			      pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
			    }
		    }
		}
	    }
	  else
	    {
	      if(pts_hst_pro->i_not_max == NOT_MIN)
		{
		  pts_hst_pro->i_not_max =pts_hst_pro->i_not;
		  pts_hst_pro->i_not_max_cost =pts_hst_pro->i_not_cost;
		  pts_hst_pro->i_not_max_pos =pts_hst_pro->i_not_pos;
		  pts_hst_pro->i_not_max_typ_mvt_pri_lea= 1;
		}

	    }
	}


}
int sim_add_l3(struct st_hash *pst_hash)
{
  struct st_hst_pro *pts_hst_pro_pp = pts_hst_pro_p -1;
  int i_not;
  int i_not_cost;
  int i_not_pos;
  int i_typ_pri_lea;
  /*
    C5F2,E2F2,H4F2 (all taken)  isn't equivalent to H4F2,E2F2,C5F2 
  */

  if (
      ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
      &&
      pts_hst_pro->i_pos_n == pts_hst_pro_p->i_pos_n
      &&
      pts_hst_pro_p->i_pos_n == pts_hst_pro_pp->i_pos_n
      )
    /* do as if the move wasn't found and don't save the move */
    /* and don't store te result */
    /* because there is no eqivalanece between the 3 subsecent moves (A B C) and (C B A) in this case */
    {
      pts_hst_pro->defv_store_result=FALSE;
      return 0;
    }
 
  /* find if the data has already been stored */
  if (rec_mvt_l3(
		 pst_hash,
		 pts_hst_pro->i_pos_ori_n,
		 pts_hst_pro->i_pos_n,
		 pts_hst_pro->i_typ_mvt,

		 pts_hst_pro_p->i_pos_ori_n,
		 pts_hst_pro_p->i_pos_n,
		 pts_hst_pro_p->i_typ_mvt,
		     
		 pts_hst_pro_pp->i_pos_ori_n,
		 pts_hst_pro_pp->i_pos_n,
		 pts_hst_pro_pp->i_typ_mvt,

		 &i_not,
		 &i_not_cost,
		 &i_not_pos,
		 &i_typ_pri_lea
		 )
      )
    {
      sim_add_l3_upl_not_max(i_not,
			     i_not_cost,
			     i_not_pos,
			     i_typ_pri_lea
			     );
 
      sim_add_l3_maj_not_max();
#ifdef ALPHA_BETA_CUT
      if ( alpha_beta_cut() )
	return 1;
#endif

      /* direction suivante meme pro */
      if(pts_hst_pro->defv_dir_sui)
	dir_sui();
      return 1; 
    }
  else
    {
      add_mvt_l3(pst_hash,pts_hst_pro->i_pos_ori_n,
		 pts_hst_pro->i_pos_n,
		 pts_hst_pro->i_typ_mvt);
      pts_hst_pro->defv_store_result=TRUE;

      return 0;
    }
}

int sto_res(struct st_hash *pst_hash)
{
  
  if (pts_hst_pro_p->defv_store_result)
    {
      pst_hash->pst_dep_cur_l3->i_not=pts_hst_pro->i_not_max;
      pst_hash->pst_dep_cur_l3->i_not_cost=pts_hst_pro->i_not_max_cost;
      pst_hash->pst_dep_cur_l3->i_not_pos=pts_hst_pro->i_not_max_pos;
      pst_hash->pst_dep_cur_l3->i_typ_pri_lea=pts_hst_pro->i_not_max_typ_mvt_pri_lea;
    }
  return 0;
}

# endif


#if CTL_DEP_ECH_PIE == 1
int ctl_dep_nbr(void)
{
  /* compare seulement le nombre de piece entre ts_ech et ts_pie*/
  int cpt_pie[2];
  int cpt_ech[2];
  int n;
  int cam;
  struct st_pie *pts_pie_ct;
 
  /* echiquier */
  cpt_ech[BLANC]=0;
  cpt_ech[NOIR ]=0;
  for (n=0;n<100;n++)
    if (ts_ech[n].i_cam == BLANC) 
      cpt_ech[BLANC]++;
    else
      if (ts_ech[n].i_cam == NOIR)
	cpt_ech[NOIR]++; 
  
  /* pieces */
  cpt_pie[BLANC]=0;
  cpt_pie[NOIR ]=0;
  for (cam=0;cam<2;cam++)
    { 
      pts_pie_ct=tpts_pie[cam] ;

      for (	pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		;
		pts_pie_ct=tpts_pie[cam]+ pts_pie_ct->i_pie_sui)
	{
	  cpt_pie[cam]++;
	  if (pts_pie_ct->i_pie_sui==17) break;

	}
    }
  /* controle egalite */
  if (
      cpt_ech[BLANC]!= cpt_pie[BLANC]
      ||
      cpt_ech[NOIR ]!= cpt_pie[NOIR ]
      )
    {
      printf("\nBlanc Ech:%i  Pie:%i", cpt_ech[BLANC], cpt_pie[BLANC]);
      printf("\nNoir  Ech:%i  Pie:%i", cpt_ech[NOIR ], cpt_pie[NOIR ]);
      return 1;
    }
  else
    return 0;
  
}
#endif

long diff_time_ms ( struct timeval a2,  struct timeval a1)
{

  /* return time difference  in milliseconds */
  long t;
  t=a2.tv_usec - a1.tv_usec;
  if(t<0)
    {
      return 
	(a2.tv_sec - a1.tv_sec-1)* 1000 
	+
	(t + 1000000) / 1000
	;
    }
  else
    {
      return  
	(a2.tv_sec - a1.tv_sec)* 1000 
	+
	(t) / 1000
	;
    }
}

static long diff_time_mcs ( struct timeval a2,  struct timeval a1)
{

  /* return time difference  in microseconds */
  long t;
  t=a2.tv_usec - a1.tv_usec;
  if(t<0)
    {
      return 
	(a2.tv_sec - a1.tv_sec-1)* 1000000 
	+
	(t + 1000000000)
	;
    }
  else
    {
      return  
	(a2.tv_sec - a1.tv_sec)* 1000000 
	+
	(t) 

	;
    }
}

